from globals import *
import globals
import debug
import object
import system
import dialog
import sys
import globaltext

__doc__= """Module for help system
"""

globaltext.IDS_VERSION_COMMENT = globaltext.IDS_VERSION_COMMENT + ", Derfflinger mod 7.4"

def Help_menu():
	if system.is_cutscene() or dialog.is_dialog_active():
		return False
	zone_name = system.get_act_mission_name() 	
	instructor_id = create_helper()
	objects.set_active_state(instructor_id,True)
	Help_Dialog(instructor_id, zone_name)

def create_helper():
	zone_name = system.get_act_mission_name()
	instructor_id = "HELP_INSTRUCTOR_"+zone_name
	if hasattr( data(zone_name), "HELPER_IS_PRESENT" ):
		return instructor_id
		
	system.create_party("HELPERS",globals.PT_COMPUTER) 
	system.create_character(
		id=instructor_id,
		gender="male",
		party = "HELPERS",
		x=20,
		y=20,
		name=globaltext.HELPER_NAME,
		direction = 90,
		resourceui="drill_instructor.png" )

	objects.set_attribute(instructor_id, "level", 1 )
	objects.set_attributes(instructor_id,
		model="low",
		gender="male",
		skin="white",
		clothes="ll_gno_guard",
		face="drill_instructor")
	character.update_appearance(instructor_id)
	character.scale(instructor_id,1.85)
	data(zone_name).HELPER_IS_PRESENT = True
	return instructor_id

def create_itemer(name):
	create_helper() 
	man_id = "ITEMER_MAN_"+name
	if not objects.exists(man_id):
		system.create_character(
			id=man_id,
			gender="male",
			party = "HELPERS",
			x=21, y=21,
			name=globaltext.HELPER_NAME,
			direction = 90,
			resourceui="drill_instructor.png" ) 
		objects.set_attributes(man_id,
			model="low",
			gender="male",
			skin="white",
			clothes="ll_gno_guard",
			face="drill_instructor")
		objects.set_active_state(man_id,0)
	if objects.has_attribute(name,"max_item_allowed") and \
		objects.get_inventory_slot_count(man_id) < objects.get_attribute(name,"max_item_allowed"):
		x = objects.get_attribute(name,"max_item_allowed") * 3
		objects.set_inventory_slot_count(man_id, x )
		objects.set_inventory_slot_count(name, x )
	return man_id

def itemers_check():
	if hasattr(data("ALTER_EGO"), "itemers"):
		x = 0
		for man_id in data("ALTER_EGO").itemers:
			objects.set_attribute(man_id, "zone_transfer", False )
			if objects.get_x(man_id) > 100:
				try:
					objects.set_position(man_id, 21+x, 21+x )
				except ValueError: # sometimes it's impossible to made a correct location for itemer.
					print "I don't touch itemer ", man_id
			objects.set_active_state(man_id,0)
			x += 1
	data("ALTER_EGO").itemers = []

sys.modules["system"].itemers_check = itemers_check

def Help_Dialog(instructor_id, zone_name):
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.add_text( text = "HELPER_GREET", speaker = instructor_id)

	if zone_name == "zone_1.zone_1":
		if system.get_qb_entry_state(data(zone_name).QB_005) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE1_QB05", follower = "A_ZONE1_QB05")
		if was_zone_entered("zone_5.zone_5"):	
			if system.get_qb_entry_state(data("zone_5.zone_5").QB_016) == COMPLETE \
				and not is_zone_enabled("zzone_3"):
				dialog.add_choice( text = "Q_ZONE1_QB16", follower = "A_ZONE1_QB16")

	elif zone_name == "zone_2.zone_2":
		if system.get_qb_entry_state(data(zone_name).QB_004) == COMPLETE and data().ben_alarm:
			dialog.add_choice( text = "Q_ZONE2_QB04", follower = "A_ZONE2_QB04")
		if system.get_qb_entry_state(data(zone_name).QB_005) == UNCOMPLETE:
			if system.get_qb_entry_state(data().QB_004) == INACTIVE \
				or ( system.get_qb_entry_state(data().QB_004) == COMPLETE and data().ben_normal_dialog):
				dialog.add_choice( text = "Q_ZONE2_QB05", follower = "A_ZONE2_QB05")
			else:
				dialog.add_choice( text = "Q_ZONE2_QB05", follower = "A_ZONE2_QB05_2")
		if system.get_qb_entry_state(data(zone_name).QB_006) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE2_QB06", follower = "A_ZONE2_QB06")
		if system.get_qb_entry_state(data(zone_name).QB_007) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE2_QB07", follower = "A_ZONE2_QB07")
		if system.get_qb_entry_state(data(zone_name).QB_011) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE2_QB11", follower = "A_ZONE2_QB11")
		if system.get_qb_entry_state(data(zone_name).QB_012) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE2_QB12", follower = "A_ZONE2_QB12")
		if system.get_qb_entry_state(data(zone_name).QB_015) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE2_QB15", follower = "A_ZONE2_QB15")
		if data().RatSkullKilledDorf > 7 and data().RatSkullKilledDorf < 10 :
			dialog.add_choice( text = "Q_ZONE2_QB16", follower = "A_ZONE2_QB16")

	elif zone_name == "zone_3.zone_3":
		if was_zone_entered("zone_2.zone_2"):
			if system.get_qb_entry_state(data("zone_2.zone_2").QB_013) == UNCOMPLETE:
				dialog.add_choice( text = "Q_ZONE3_QB00", follower = "A_ZONE3_QB00")
		if system.get_qb_entry_state(data(zone_name).QB_015) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE3_QB15", follower = "A_ZONE3_QB15")
		if system.get_qb_entry_state(data(zone_name).QB_020) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE3_QB20", follower = "A_ZONE3_QB20")
		if system.get_qb_entry_state(data(zone_name).QB_021) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE3_QB21", follower = "A_ZONE3_QB21")

	elif zone_name == "zone_4.zone_4":
		if was_zone_entered("zone_2.zone_2"):
			if system.get_qb_entry_state(data("zone_2.zone_2").QB_014) == UNCOMPLETE \
				and system.get_qb_entry_state(data(zone_name).QB_004) == COMPLETE \
				and system.get_qb_entry_state(data(zone_name).QB_002) == INACTIVE \
				and system.get_qb_entry_state(data(zone_name).QB_003) == INACTIVE:
				dialog.add_choice( text = "Q_ZONE4_QB00", follower = "A_ZONE4_QB00")
		if system.get_qb_entry_state(data(zone_name).QB_002) == UNCOMPLETE \
			and not system.get_qb_entry_state(data(zone_name).QB_004) == COMPLETE:
			dialog.add_choice( text = "Q_ZONE4_QB02", follower = "A_ZONE4_QB02")
		if system.get_qb_entry_state(data(zone_name).QB_003) == UNCOMPLETE \
			and not system.get_qb_entry_state(data(zone_name).QB_004) == COMPLETE:
			dialog.add_choice( text = "Q_ZONE4_QB03", follower = "A_ZONE4_QB03")
		if system.get_qb_entry_state(data(zone_name).QB_010) == UNCOMPLETE \
			and len(data().FortRatSkulls) < 4:
			dialog.add_choice( text = "Q_ZONE4_QB04", follower = "A_ZONE4_QB04")
		if system.get_qb_entry_state(data(zone_name).QB_005) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE4_QB05", follower = "A_ZONE4_QB05")
		if system.get_qb_entry_state(data(zone_name).QB_006) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE4_QB06", follower = "A_ZONE4_QB06")
		if system.get_qb_entry_state(data(zone_name).QB_007) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE4_QB07", follower = "A_ZONE4_QB07")
		if system.get_qb_entry_state(data(zone_name).QB_008) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE4_QB08", follower = "A_ZONE4_QB08")
		if (system.get_qb_entry_state(data(zone_name).QB_002) == UNCOMPLETE \
			or system.get_qb_entry_state(data(zone_name).QB_003) == UNCOMPLETE) \
			and system.get_qb_entry_state(data(zone_name).QB_004) == COMPLETE:
			dialog.add_choice( text = "Q_ZONE4_QB09", follower = "A_ZONE4_QB09")
		if system.get_qb_entry_state(data(zone_name).QB_010) == COMPLETE and not data(zone_name).scientists_rescued:
			dialog.add_choice( text = "Q_ZONE4_QB10", follower = "A_ZONE4_QB10")
		if data(zone_name).scientists_rescued and system.get_qb_entry_state(data(zone_name).QB_011) == INACTIVE \
			and system.get_qb_entry_state(data(zone_name).QB_012) == INACTIVE:
			dialog.add_choice( text = "Q_ZONE4_QB11", follower = "A_ZONE4_QB11")
		if system.get_qb_entry_state(data(zone_name).QB_011) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE4_QB12", follower = "A_ZONE4_QB12")
		if system.get_qb_entry_state(data(zone_name).QB_014) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE4_QB14", follower = "A_ZONE4_QB14")
		if system.get_qb_entry_state(data(zone_name).QB_018) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE4_QB18", follower = "A_ZONE4_QB18")
		if system.get_qb_entry_state(data(zone_name).QB_020) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE4_QB20", follower = "A_ZONE4_QB20")

	elif zone_name == "zone_5.zone_5":
		if system.get_qb_entry_state(data(zone_name).QB_006) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE5_QB06", follower = "A_ZONE5_QB06")
		if system.get_qb_entry_state(data(zone_name).QB_017) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE5_QB17", follower = "A_ZONE5_QB17")
		if data().kill_wasser < 20 and data().kill_wasser > 17:
			dialog.add_choice( text = "Q_ZONE5_QB25", follower = "A_ZONE5_QB25")

	elif zone_name == "zone_6.zone_6":
		if system.get_qb_entry_state(data(zone_name).QB_005) == UNCOMPLETE \
			and pc_is_stucked():
			dialog.add_choice( text = "Q_ZONE6_QB04", follower = "A_ZONE6_QB04")
		if system.get_qb_entry_state(data(zone_name).QB_008) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE6_QB08", follower = "A_ZONE6_QB08")
		if system.get_qb_entry_state(data(zone_name).QB_012) == UNCOMPLETE \
			or system.get_qb_entry_state(data(zone_name).QB_017) == UNCOMPLETE:		
			dialog.add_choice( text = "Q_ZONE6_QB12", follower = "A_ZONE6_QB12")			
		if system.get_qb_entry_state(data(zone_name).QB_013) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE6_QB13", follower = "A_ZONE6_QB13")
		if system.get_qb_entry_state(data(zone_name).QB_014) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE6_QB14", follower = "A_ZONE6_QB14")
		if system.get_qb_entry_state(data(zone_name).QB_015) == UNCOMPLETE \
			and system.get_qb_entry_state(data(zone_name).QB_018) == INACTIVE:
			dialog.add_choice( text = "Q_ZONE6_QB15", follower = "A_ZONE6_QB15")
		if system.get_qb_entry_state(data(zone_name).QB_016) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE6_QB16", follower = "A_ZONE6_QB16")	
		if system.get_qb_entry_state(data(zone_name).QB_018) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE6_QB18", follower = "A_ZONE6_QB18")
		if system.get_qb_entry_state(data(zone_name).QB_015) == UNCOMPLETE \
			and system.get_qb_entry_state(data(zone_name).QB_018) == COMPLETE:
			dialog.add_choice( text = "Q_ZONE6_QB22", follower = "A_ZONE6_QB22")
		if data().SchattenCopperHillGetoetet < len(data().SCHATTEN_NPCS) \
			and data().SchattenCopperHillGetoetet > len(data().SCHATTEN_NPCS) - 3:
			dialog.add_choice( text = "Q_ZONE6_QB25", follower = "A_ZONE6_QB25")
			
	elif zone_name == "zone_7.zone_7":
		if system.get_qb_entry_state(data(zone_name).QB_004) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE7_QB04", follower = "A_ZONE7_QB04")
		if system.get_qb_entry_state(data(zone_name).QB_005) == COMPLETE and not data().hostages_rescued:
			dialog.add_choice( text = "Q_ZONE7_QB05", follower = "A_ZONE7_QB05")
		if system.get_qb_entry_state(data(zone_name).QB_006) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE7_QB06", follower = "A_ZONE7_QB06")
		if system.get_qb_entry_state(data(zone_name).QB_008) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE7_QB08", follower = "A_ZONE7_QB08")
		if system.get_qb_entry_state(data(zone_name).QB_010) == UNCOMPLETE \
			or system.get_qb_entry_state(data(zone_name).QB_011) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE7_QB10", follower = "A_ZONE7_QB10")
		if system.get_qb_entry_state(data(zone_name).QB_012) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE7_QB12", follower = "A_ZONE7_QB12")
		if data().Counter_AlleSchattenKilled < len(data().SCHATTEN_NPCS) \
			and data().Counter_AlleSchattenKilled > len(data().SCHATTEN_NPCS) / 2:
			dialog.add_choice( text = "Q_ZONE7_QB01", follower = "A_ZONE7_QB01")	

	elif zone_name == "zone_8.zone_8":
		if system.get_qb_entry_state(data(zone_name).QB_004) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE8_QB04", follower = "A_ZONE8_QB04")
		if system.get_qb_entry_state(data(zone_name).QB_005) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE8_QB05", follower = "A_ZONE8_QB05")
		if system.get_qb_entry_state(data(zone_name).QB_010) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE8_QB10", follower = "A_ZONE8_QB10")

	elif zone_name == "zone_9.zone_9":
		if system.get_qb_entry_state(data(zone_name).QB_002) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE9_QB02", follower = "A_ZONE9_QB02")	
		if system.get_qb_entry_state(data(zone_name).QB_004) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE9_QB04", follower = "A_ZONE9_QB04")
		if system.get_qb_entry_state(data(zone_name).QB_006) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE9_QB06", follower = "A_ZONE9_QB06")	
		if system.get_qb_entry_state(data(zone_name).QB_007) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE9_QB07", follower = "A_ZONE9_QB07")
		if system.get_qb_entry_state(data(zone_name).QB_010) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE9_QB10", follower = "A_ZONE9_QB10")
		if system.get_qb_entry_state(data(zone_name).QB_013) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZONE9_QB13", follower = "A_ZONE9_QB13")
			
	elif zone_name == "sqzone_2.sqzone_2":
		if was_zone_entered("zone_3.zone_3"):
			if system.get_qb_entry_state(data("zone_3.zone_3").QB_024) == UNCOMPLETE:
				dialog.add_choice( text = "Q_SZONE2_QB24", follower = "A_SZONE2_QB24")

	elif zone_name == "sqzone_3.sqzone_3":
		if was_zone_entered("zone_4.zone_4"):
			if system.get_qb_entry_state(data("zone_4.zone_4").QB_020) == UNCOMPLETE:
				dialog.add_choice( text = "Q_SZONE3_QB20", follower = "A_SZONE3_QB20")

	elif zone_name == "zzone_4.zzone_4":
		if system.get_qb_entry_state(data(zone_name).QB_001) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZZONE4_QB01", follower = "A_ZZONE4_QB01")
		if system.get_qb_entry_state(data(zone_name).QB_002) == UNCOMPLETE \
			and not objects.is_destroyed(data().Ians_actual_name):
			dialog.add_choice( text = "Q_ZZONE4_QB02", follower = "A_ZZONE4_QB02")
		if system.get_qb_entry_state(data(zone_name).QB_003) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZZONE4_QB03", follower = "A_ZZONE4_QB03")
		if system.get_qb_entry_state(data(zone_name).QB_002) == UNCOMPLETE \
			and objects.is_destroyed(data().Ians_actual_name):
			dialog.add_choice( text = "Q_ZZONE4_QB04", follower = "A_ZZONE4_QB04")
			
			
	elif zone_name == "zzone_5.zzone_5":
		if system.get_qb_entry_state(data(zone_name).QB_001) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZZONE5_QB01", follower = "A_ZZONE5_QB01")

	elif zone_name == "zzone_6.zzone_6":
		if system.get_qb_entry_state(data(zone_name).QB_001) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZZONE6_QB01", follower = "A_ZZONE6_QB01")

	elif zone_name == "zzone_10.zzone_10":
		if system.get_qb_entry_state(data(zone_name).QB_001) == UNCOMPLETE:
			dialog.add_choice( text = "Q_ZZONE10_QB01", follower = "A_ZZONE10_QB01")


	dialog.add_choice( text = "HELPER_EXIT", follower = "ENDDIALOG", callback = Help_menu_exit )

	if zone_name == "zone_1.zone_1":
		if system.get_qb_entry_state(data(zone_name).QB_005) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE1_QB05", speaker = instructor_id, follower = "HELPER_GREET")
		if was_zone_entered("zone_5.zone_5"):	
			if system.get_qb_entry_state(data("zone_5.zone_5").QB_016) == COMPLETE \
				and not is_zone_enabled("zzone_3"):
				dialog.add_text( text = "A_ZONE1_QB16", speaker = instructor_id, follower = "HELPER_GREET")	

	elif zone_name == "zone_2.zone_2":
		if system.get_qb_entry_state(data(zone_name).QB_004) == COMPLETE and data().ben_alarm:
			dialog.add_text( text = "A_ZONE2_QB04", speaker = instructor_id, callback=Help_Zone_bug, follower = "ENDDIALOG")
		if system.get_qb_entry_state(data(zone_name).QB_005) == UNCOMPLETE:
			if system.get_qb_entry_state(data().QB_004) == INACTIVE \
				or ( system.get_qb_entry_state(data().QB_004) == COMPLETE and data().ben_normal_dialog):
				dialog.add_text( text = "A_ZONE2_QB05", speaker = instructor_id, follower = "HELPER_GREET")
			else:
				dialog.add_text( text = "A_ZONE2_QB05_2", speaker = instructor_id, follower = "HELPER_GREET")			
		if system.get_qb_entry_state(data(zone_name).QB_006) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE2_QB06", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_007) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE2_QB07", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_011) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE2_QB11", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_012) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE2_QB12", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_015) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE2_QB15", speaker = instructor_id, follower = "HELPER_GREET")
		if data().RatSkullKilledDorf > 7 and data().RatSkullKilledDorf < 10 :
			dialog.add_text( text = "A_ZONE2_QB16", speaker = instructor_id, callback=Help_Zone, follower = "ENDDIALOG")

	elif zone_name == "zone_3.zone_3":
		if was_zone_entered("zone_2.zone_2"):
			if system.get_qb_entry_state(data("zone_2.zone_2").QB_013) == UNCOMPLETE:
				dialog.add_text( text = "A_ZONE3_QB00", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_015) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE3_QB15", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_020) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE3_QB20", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_021) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE3_QB21", speaker = instructor_id, follower = "HELPER_GREET")

	elif zone_name == "zone_4.zone_4":
		if was_zone_entered("zone_2.zone_2"):
			if system.get_qb_entry_state(data("zone_2.zone_2").QB_014) == UNCOMPLETE \
				and system.get_qb_entry_state(data(zone_name).QB_004) == COMPLETE \
				and system.get_qb_entry_state(data(zone_name).QB_002) == INACTIVE \
				and system.get_qb_entry_state(data(zone_name).QB_003) == INACTIVE:
				dialog.add_text( text = "A_ZONE4_QB00", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_002) == UNCOMPLETE \
			and not system.get_qb_entry_state(data(zone_name).QB_004) == COMPLETE:
			dialog.add_text( text = "A_ZONE4_QB02", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_003) == UNCOMPLETE \
			and not system.get_qb_entry_state(data(zone_name).QB_004) == COMPLETE:
			dialog.add_text( text = "A_ZONE4_QB03", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_010) == UNCOMPLETE \
			and len(data().FortRatSkulls) < 4:
			dialog.add_text( text = "A_ZONE4_QB04", speaker = instructor_id, callback=Help_Zone, follower = "ENDDIALOG")
		if system.get_qb_entry_state(data(zone_name).QB_005) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE4_QB05", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_006) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE4_QB06", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_007) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE4_QB07", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_008) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE4_QB08", speaker = instructor_id, follower = "HELPER_GREET")
		if (system.get_qb_entry_state(data(zone_name).QB_002) == UNCOMPLETE \
			or system.get_qb_entry_state(data(zone_name).QB_003) == UNCOMPLETE) \
			and system.get_qb_entry_state(data(zone_name).QB_004) == COMPLETE:
			dialog.add_text( text = "A_ZONE4_QB09", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_010) == COMPLETE and not data(zone_name).scientists_rescued:
			dialog.add_text( text = "A_ZONE4_QB10", speaker = instructor_id, follower = "HELPER_GREET")
		if data(zone_name).scientists_rescued and system.get_qb_entry_state(data(zone_name).QB_011) == INACTIVE \
			and system.get_qb_entry_state(data(zone_name).QB_012) == INACTIVE:
			dialog.add_text( text = "A_ZONE4_QB11", speaker = instructor_id, callback=Help_Zone_bug, follower = "ENDDIALOG")
		if system.get_qb_entry_state(data(zone_name).QB_011) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE4_QB12", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_014) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE4_QB14", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_018) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE4_QB18", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_020) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE4_QB20", speaker = instructor_id, follower = "HELPER_GREET")

	elif zone_name == "zone_5.zone_5":
		if system.get_qb_entry_state(data(zone_name).QB_006) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE5_QB06", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_017) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE5_QB17", speaker = instructor_id, follower = "HELPER_GREET")
		if data().kill_wasser < 20 and data().kill_wasser > 17:		
			dialog.add_text( text = "A_ZONE5_QB25", speaker = instructor_id, callback=Help_Zone, follower = "ENDDIALOG")

	elif zone_name == "zone_6.zone_6":
		if system.get_qb_entry_state(data(zone_name).QB_005) == UNCOMPLETE \
			and pc_is_stucked():
			dialog.add_text( text = "A_ZONE6_QB04", speaker = instructor_id, callback=Help_Zone_bug, follower = "ENDDIALOG")
		if system.get_qb_entry_state(data(zone_name).QB_008) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE6_QB08", speaker = instructor_id, follower = "HELPER_GREET")		
		if system.get_qb_entry_state(data(zone_name).QB_012) == UNCOMPLETE \
			or system.get_qb_entry_state(data(zone_name).QB_017) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE6_QB12", speaker = instructor_id, follower = "HELPER_GREET")	
		if system.get_qb_entry_state(data(zone_name).QB_013) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE6_QB13", speaker = instructor_id, follower = "HELPER_GREET")			
		if system.get_qb_entry_state(data(zone_name).QB_014) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE6_QB14", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_015) == UNCOMPLETE \
			and system.get_qb_entry_state(data(zone_name).QB_018) == INACTIVE:
			dialog.add_text( text = "A_ZONE6_QB15", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_016) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE6_QB16", speaker = instructor_id, follower = "HELPER_GREET")	
		if system.get_qb_entry_state(data(zone_name).QB_018) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE6_QB18", speaker = instructor_id, follower = "HELPER_GREET")	
		if system.get_qb_entry_state(data(zone_name).QB_015) == UNCOMPLETE \
			and system.get_qb_entry_state(data(zone_name).QB_018) == COMPLETE:
			dialog.add_text( text = "A_ZONE6_QB22", speaker = instructor_id, follower = "HELPER_GREET")
		if data().SchattenCopperHillGetoetet < len(data().SCHATTEN_NPCS) \
			and data().SchattenCopperHillGetoetet > len(data().SCHATTEN_NPCS) - 3:
			dialog.add_text( text = "A_ZONE6_QB25", speaker = instructor_id, callback=Help_Zone, follower = "ENDDIALOG")	

	elif zone_name == "zone_7.zone_7":
		if system.get_qb_entry_state(data(zone_name).QB_004) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE7_QB04", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_005) == COMPLETE and not data().hostages_rescued:
			dialog.add_text( text = "A_ZONE7_QB05", speaker = instructor_id, callback=Help_Zone, follower = "ENDDIALOG")
		if system.get_qb_entry_state(data(zone_name).QB_006) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE7_QB06", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_008) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE7_QB08", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_010) == UNCOMPLETE \
			or system.get_qb_entry_state(data(zone_name).QB_011) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE7_QB10", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_012) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE7_QB12", speaker = instructor_id, follower = "HELPER_GREET")
		if data().Counter_AlleSchattenKilled < len(data().SCHATTEN_NPCS) \
			and data().Counter_AlleSchattenKilled > len(data().SCHATTEN_NPCS) / 2:
			dialog.add_text( text = "A_ZONE7_QB01", speaker = instructor_id, callback=Help_Zone, follower = "ENDDIALOG")

	elif zone_name == "zone_8.zone_8":
		if system.get_qb_entry_state(data(zone_name).QB_004) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE8_QB04", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_005) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE8_QB05", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_010) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE8_QB10", speaker = instructor_id, follower = "HELPER_GREET")

	elif zone_name == "zone_9.zone_9":
		if system.get_qb_entry_state(data(zone_name).QB_002) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE9_QB02", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_004) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE9_QB04", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_006) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE9_QB06", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_007) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE9_QB07", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_010) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE9_QB10", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_013) == UNCOMPLETE:
			dialog.add_text( text = "A_ZONE9_QB13", speaker = instructor_id, follower = "HELPER_GREET")

	elif zone_name == "sqzone_2.sqzone_2":
		if was_zone_entered("zone_3.zone_3"):
			if system.get_qb_entry_state(data("zone_3.zone_3").QB_024) == UNCOMPLETE:
				dialog.add_text( text = "A_SZONE2_QB24", speaker = instructor_id, follower = "HELPER_GREET")

	elif zone_name == "sqzone_3.sqzone_3":
		if was_zone_entered("zone_4.zone_4"):
			if system.get_qb_entry_state(data("zone_4.zone_4").QB_020) == UNCOMPLETE:
				dialog.add_text( text = "A_SZONE3_QB20", speaker = instructor_id, follower = "HELPER_GREET")

	elif zone_name == "zzone_4.zzone_4":
		if system.get_qb_entry_state(data(zone_name).QB_001) == UNCOMPLETE:
			dialog.add_text( text = "A_ZZONE4_QB01", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_002) == UNCOMPLETE \
			and not objects.is_destroyed(data().Ians_actual_name):
			dialog.add_text( text = "A_ZZONE4_QB02", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_003) == UNCOMPLETE:
			dialog.add_text( text = "A_ZZONE4_QB03", speaker = instructor_id, follower = "HELPER_GREET")
		if system.get_qb_entry_state(data(zone_name).QB_002) == UNCOMPLETE \
			and objects.is_destroyed(data().Ians_actual_name):		
			dialog.add_text( text = "A_ZZONE4_QB04", speaker = instructor_id, follower = "HELPER_GREET" )
			
	elif zone_name == "zzone_5.zzone_5":
		if system.get_qb_entry_state(data(zone_name).QB_001) == UNCOMPLETE:
			dialog.add_text( text = "A_ZZONE5_QB01", speaker = instructor_id, follower = "HELPER_GREET")

	elif zone_name == "zzone_6.zzone_6":
		if system.get_qb_entry_state(data(zone_name).QB_001) == UNCOMPLETE:
			dialog.add_text( text = "A_ZZONE6_QB01", speaker = instructor_id, follower = "HELPER_GREET")

	elif zone_name == "zzone_10.zzone_10":
		if system.get_qb_entry_state(data(zone_name).QB_001) == UNCOMPLETE:
			dialog.add_text( text = "A_ZZONE10_QB01", speaker = instructor_id, follower = "HELPER_GREET")

	dialog.start()	
	
def Help_menu_exit():
	zone_name = system.get_act_mission_name() 	
	instructor_id = "HELP_INSTRUCTOR_"+zone_name
	objects.set_active_state(instructor_id,False)	
	
def Help_Zone_bug():
	zone_name = system.get_act_mission_name() 	
	instructor_id = "HELP_INSTRUCTOR_"+zone_name
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.add_text( text = "A_ZONE4_BUG_1", speaker = instructor_id)
	dialog.add_choice( text = "Q_ZONE4_BUG_2", follower = "A_ZONE4_BUG_4")
	dialog.add_choice( text = "Q_ZONE4_BUG_3", follower = "A_ZONE4_BUG_5")
	dialog.add_text( text = "A_ZONE4_BUG_4", speaker = instructor_id, callback=Try_Help_Zone, follower = "ENDDIALOG")
	dialog.add_text( text = "A_ZONE4_BUG_5", speaker = instructor_id, follower = "ENDDIALOG")
	dialog.start()	

def Help_Zone():
	zone_name = system.get_act_mission_name()
	instructor_id = "HELP_INSTRUCTOR_"+zone_name
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.add_text( text = "A_ZONE4_BUG_6", speaker = instructor_id)
	dialog.add_choice( text = "Q_ZONE4_BUG_2", follower = "A_ZONE4_BUG_4")
	dialog.add_choice( text = "Q_ZONE4_BUG_3", follower = "A_ZONE4_BUG_5")
	dialog.add_text( text = "A_ZONE4_BUG_4", speaker = instructor_id, callback=Try_Help_Zone_2, follower = "ENDDIALOG")
	dialog.add_text( text = "A_ZONE4_BUG_5", speaker = instructor_id, follower = "ENDDIALOG")
	dialog.start()		

def Do_Nothing():
	print "I trying to do nothing"

def Try_Help_Zone():
	zone_name = system.get_act_mission_name() 	
	print "I trying to fix bug at zone", zone_name	
	if zone_name == "zone_2.zone_2":
		import zone_2
		zone_2.zone_2.BenGibtSignal()
	elif zone_name == "zone_4.zone_4":
		import zone_4	
		zone_4.dialogs.initDlg_065_Erste_Begegnung()
	elif zone_name == "zone_6.zone_6":
		import zone_6
		i = 0
		for pc in system.get_pcs():
			objects.set_position(object=pc, x=740+i, y=237+i)
			i += 1		

def Try_Help_Zone_2():
	zone_name = system.get_act_mission_name() 	
	print "I trying to help with zone", zone_name
	if zone_name == "zone_2.zone_2":
		import zone_2
		for enemy in data().ratskulls_village :
			if not objects.is_destroyed(enemy):
				break	
		for id in system.get_pcs():
			objects.cancel_commandos(id)
			objects.turn_to_object(id, enemy)	
	elif zone_name == "zone_4.zone_4":
		import zone_4		
		if data().FortRatSkulls != []:
			for id in system.get_pcs():
				objects.cancel_commandos(id)
				objects.turn_to_object(id,data().FortRatSkulls[0])
	elif zone_name == "zone_5.zone_5":
		import zone_5.const 
		for enemy in zone_5.const.NPC_RATSKULLS_WASSER:
			if not objects.is_destroyed(enemy):
				break
		for id in system.get_pcs():
			objects.cancel_commandos(id)
			objects.turn_to_object(id, enemy)	
	elif zone_name == "zone_6.zone_6":
		import zone_6
		for enemy in data().SCHATTEN_NPCS:
			if not objects.is_destroyed(enemy):
				break			
		for id in system.get_pcs():
			objects.cancel_commandos(id)
			objects.turn_to_object(id, enemy)
	elif zone_name == "zone_7.zone_7":
		import zone_7
		if data().Counter_AlleSchattenKilled < len(data().SCHATTEN_NPCS):
			for enemy in data().SCHATTEN_NPCS:
				if not objects.is_destroyed(enemy):
					break			
			for id in system.get_pcs():
				objects.cancel_commandos(id)
				objects.turn_to_object(id, enemy)
		else:
			for id in system.get_pcs():
				objects.cancel_commandos(id)
				objects.turn_to_object(id, data().qi_cagekey[0] )

def pc_is_stucked():
	for pc in system.get_pcs():
		x = objects.get_x(pc)
		y = objects.get_y(pc)
		if (x-727)**2+(y-232)**2 < 16:
			return True
	return False		

#----------------------

