# -*- coding: utf-8 -*-
from global_defines import *
import dialogs
import npc
from const import *
import water
import object_events
import schedules
from dynamic_camera import *
import system_events
import enemy_script
import skies
import globaltext
import sounds
import dialog
from daily_routine import *
import spawnanimals

#*********************************************************************
#		aktuelle revison: Revision 33, 6.10.2004 und 36 und 40
#*********************************************************************

#äöü

def initParties():
	system.create_party(id="UISPIELER",type=PT_HUMAN)
	system.create_party(id="NPCS",type=PT_COMPUTER)
	system.create_party(id="RATSKULLS",type=PT_COMPUTER)
	system.create_party(id="ANIMALS",type=PT_COMPUTER)

def GetZoneEnterLocation(enterdirection):
	start_locations = \
		{	"NORTH":	(322.5, 851.6),
	 		"SOUTH":	(322.5, 851.6),
	 		"WEST":		(322.5, 851.6),
	 		"EAST":		(322.5, 851.6),
	 	}

	if (enterdirection in start_locations.keys()):
		return start_locations[enterdirection]
	else:
		raise ValueError, "no spawn location for this direction registered: " + enterdirection
def GetZoneEnterLocationVehicles(enterdirection):
	start_locations = \
		{	"NORTH":	(321.27, 835.18),
	 		"SOUTH":	(321.27, 835.18),
	 		"WEST":		(321.27, 835.18),
	 		"EAST":		(321.27, 835.18),
	 	}

	if (enterdirection in start_locations.keys()):
		return start_locations[enterdirection]
	else:
		raise ValueError, "no spawn location for this direction registered: " + enterdirection		

def on_init():
	skies.init_sky_preset("redrock")

def init_non_rest_areas():
	data("rest").non_rest_areas = []
	if not hasattr(data(), "has_non_rest_areas"):
		data().has_non_rest_areas = True
		#spezielle non rest regionen
		system.add_region("Dorf",215,810,385,565)
		system.add_region("Basis_der_Ratskulls",485,435,645,275)
		system.add_region("Klonstation",705,665,775,630)
		system.add_region("Tizocs_Haus",695,485,665,515)
		system.add_region("Fundort_Hummer",510,780,535,745)
		system.add_region("Posten_der_Ratskulls_im_SW",465,530,495,495)
		system.add_region("Posten_der_Ratskulls_im_NW",420,275,465,405)
		system.add_region("Posten_der_Ratskulls_im_NO",575,465,633,436)
	
	data("rest").non_rest_areas.append("Dorf")
	data("rest").non_rest_areas.append("Basis_der_Ratskulls")
	data("rest").non_rest_areas.append("Klonstation")
	data("rest").non_rest_areas.append("Tizocs_Haus")
	data("rest").non_rest_areas.append("Fundort_Hummer")
	data("rest").non_rest_areas.append("Posten_der_Ratskulls_im_SW")
	data("rest").non_rest_areas.append("Posten_der_Ratskulls_im_NW")
	data("rest").non_rest_areas.append("Posten_der_Ratskulls_im_NO")
	
	#minenfelder extra
	data("rest").non_rest_areas.append("REGION_MINES_1")
	data("rest").non_rest_areas.append("REGION_MINES_2")
	data("rest").non_rest_areas.append("REGION_MINES_3")
	data("rest").non_rest_areas.append("REGION_MINES_4")

def on_map_loaded():
	init_data()
	initParties()
	# place vehicles
	location = GetZoneEnterLocationVehicles( system.zone_transfer_get_direction() )
	system.zone_transfer_place_vehicles( location[0], location[1] )
	# place player characters
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	#location = GetZoneEnterLocation( "WEST" )
	system.zone_transfer_place_characters( location[0], location[1] )
	
	# ae- and party-creation modifier | see debug_py.py for info on parameters
	import debug; debug.cheat_party(party=False, x=location[0], y=location[1])
	
	npc.initNPCS()
	npc.initAnimals()
	init_CLIVE()
	
	init_character_states()
	
	## Timer für die Tierspawns
	on_timer(data().Timer_SpawnTimeChecker)
	#system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)
	
	
	initExitZones()
	initRegions()
	initItems()
	initHerbs()
	initFX()
	initMinimapMarkers()
	initSounds()
	initWaterResources()
	initFoeLists()
	initQuestBook()

	# Schatten zur Leiche machen
	objects.destroy("SCHATTENLEICHE")
	
	objects.set_active_state("PEGGY",False)
	## hummer
	system.create_object("SET_HUMVEE",513.8,763.3,'Z5 HUMMER',10)
	objects.set_attribute('Z5 HUMMER',"accepted_drivers",["RATSKULL_HUMMER_1","RATSKULL_HUMMER_2"])
	checkZoneDependencys()
	init_scriptuse_objects()
	InitChestsSafes()
	system.notify_timer(data().Timer_RatskullDrogenkuriereAufhalten, data().Timervalue_RatskullDrogenkuriereAufhalten)
	
	### todo sollte das Problem mit dem nichtvorhandensein von Waffen obwohl Equipt behoben sein,
	### können die beiden folgenden Funkt. raus
	#for pcid in system.get_pcs():
	#	character.unequip_hands(pcid)
	#	character.arm_direct(pcid)
	
	## start situation: wesley approaches, patrick routes around the map
	setWesleyBegruessung()
	setPatrickPouting()
	schedules.init_schedules() ## immer nach dem initQuestbook()
	anim_windrad()
	init_non_rest_areas()
	system.notify_timer(data().Timer_Wargversammlung,data().Timervalue_Wargversammlung)
	initVehicles()
	init_main_npcs()
	
	init_difficulty_increase()
	if hasattr(data('zone_8.zone_8'),'BruchMitHayes') and data('zone_8.zone_8').BruchMitHayes and not data().Bruch_Mit_Hayes:
		data().Bruch_Mit_Hayes = True

def anim_windrad(objectid=None):
	objects.play_animation('BUILDING_2336','ANIM_WINDRAD',callback=['ONEND',anim_windrad])
	if not hasattr(data(),"windradsound"):
		data().windradsound=True
		sounds.play_3d_sound_object(sfx_id="working_windmill",object='BUILDING_2336', loop=True)

## init sound files (pre-load)
def initSounds():
	# alarm in ratskullcamp
	#sounds.load_sound(sfx_id='shell_alarm')
	# explosion of hummer
	sounds.load_sound(sfx_id='grenade_explo_frag')
	sounds.load_sound(sfx_id='grenade_explo_rpg7')
	sounds.load_sound(sfx_id='various_explosive_explo')
	
	sounds.load_sound(sfx_id="weeping_female")
	sounds.load_sound(sfx_id="warg_whines_2")
	sounds.load_sound(sfx_id="warg_whines")
	sounds.load_sound(sfx_id="warg_snarls")
	sounds.load_sound(sfx_id="smooth_firecracks")
	sounds.load_sound(sfx_id="falling_buckets")
	system.notify_timer(data().Timer_OliviaSound, 9000)

	sounds.load_sound(sfx_id="humvee_explosion")
	sounds.load_sound(sfx_id="humvee_closing_door")
	sounds.load_sound(sfx_id="humvee_failstart")
	sounds.load_sound(sfx_id="humvee_opening_door")

## init questbook entrys
def initQuestBook():
	data().QB_001 = system.register_qb_entry('ZONE5_AIM_01', id_history = 'ZONE5_AIM_01')
	data().QB_002 = system.register_qb_entry('ZONE5_AIM_02', id_history = 'ZONE5_AIM_01')
	data().QB_003 = system.register_qb_entry('ZONE5_AIM_03', id_history = 'ZONE5_AIM_01')
	data().QB_004 = system.register_qb_entry('ZONE5_AIM_04', id_history = 'ZONE5_AIM_01')
	data().QB_005 = system.register_qb_entry('ZONE5_AIM_05', id_history = 'ZONE5_AIM_17')
	data().QB_006 = system.register_qb_entry('ZONE5_AIM_06', id_history = 'ZONE5_AIM_06')
	data().QB_007 = system.register_qb_entry('ZONE5_AIM_07', id_history = 'ZONE5_AIM_07')
	data().QB_008 = system.register_qb_entry('ZONE5_AIM_08', id_history = 'ZONE5_AIM_17')
	data().QB_009 = system.register_qb_entry('ZONE5_AIM_09', id_history = 'ZONE5_AIM_07')
	data().QB_010 = system.register_qb_entry('ZONE5_AIM_10', id_history = 'ZONE5_AIM_07')
	data().QB_011 = system.register_qb_entry('ZONE5_AIM_11', id_history = 'ZONE5_AIM_11')
	data().QB_012 = system.register_qb_entry('ZONE5_AIM_12', id_history = 'ZONE4_AIM_21')
	data().QB_013 = system.register_qb_entry('ZONE5_AIM_13', id_history = 'ZONE4_AIM_03')
	data().QB_014 = system.register_qb_entry('ZONE5_AIM_14', id_history = 'ZONE5_AIM_14')
	# data().QB_015 = system.register_qb_entry('ZONE5_AIM_15', id_history = 'ZONE5_AIM_15')
	data().QB_016 = system.register_qb_entry('ZONE5_AIM_16', id_history = 'ZONE4_AIM_14')
	data().QB_017 = system.register_qb_entry('ZONE5_AIM_17', id_history = 'ZONE5_AIM_17')
	data().QB_018 = system.register_qb_entry('ZONE5_AIM_18', id_history = 'ZONE5_AIM_18')
	

## mark items that are uses by scripting
def init_scriptuse_objects():
	system.mark_for_script_use("BUILDING_2659")
	for lf in OBJ_LAGERFEUER:
		system.mark_for_script_use(lf)

	#kisten truhen tresore
	system.mark_for_script_use("BUILDING_15828")
	system.mark_for_script_use("BUILDING_15842")
	system.mark_for_script_use("BUILDING_15851")
	system.mark_for_script_use("BUILDING_15855")
	system.mark_for_script_use("BUILDING_15856")
	system.mark_for_script_use("BUILDING_15864")
	system.mark_for_script_use("BUILDING_15865")
	system.mark_for_script_use("BUILDING_13681")
	system.mark_for_script_use("BUILDING_15867")
	system.mark_for_script_use("BUILDING_13258")
	system.mark_for_script_use("BUILDING_13517")
	system.mark_for_script_use("BUILDING_15886")
	system.mark_for_script_use("BUILDING_13188")
	system.mark_for_script_use("BUILDING_3189")

	# Bienenstöcke Zone 5
	system.mark_for_script_use('BUILDING_15986')
	system.mark_for_script_use('BUILDING_15985')
	system.mark_for_script_use('BUILDING_15984')
	system.mark_for_script_use('BUILDING_15987')
	# system.mark_for_script_use('BUILDING_15983')


	# windrad
	system.mark_for_script_use("BUILDING_2336")

## check if another zone had been entered
def checkZoneDependencys():
	pass
			
## init all region triggers
def initRegions():
	# Flugblaetter Regionen
	system.add_region("REGION_POSTER_1",356,650,348,642)
	system.notify_region_entered(region="REGION_POSTER_1",partyid="UISPIELER" )
	system.add_region("REGION_POSTER_2",233,717,225,709)
	system.notify_region_entered(region="REGION_POSTER_2",partyid="UISPIELER" )
	system.add_region("REGION_POSTER_3",243,664,235,656)
	system.notify_region_entered(region="REGION_POSTER_3",partyid="UISPIELER" )
	system.add_region("REGION_POSTER_4",246,771,238,763)
	system.notify_region_entered(region="REGION_POSTER_4",partyid="UISPIELER" )
	system.add_region("REGION_POSTER_5",333,786,325,778)
	system.notify_region_entered(region="REGION_POSTER_5",partyid="UISPIELER" )
	system.add_region("REGION_POSTER_6",344,744,336,736)
	system.notify_region_entered(region="REGION_POSTER_6",partyid="UISPIELER" )
	system.add_region("REGION_POSTER_7",349,720,341,712)
	system.notify_region_entered(region="REGION_POSTER_7",partyid="UISPIELER" )
	system.add_region("REGION_POSTER_8",350,619,342,611)
	system.notify_region_entered(region="REGION_POSTER_8",partyid="UISPIELER" )
	system.add_region("REGION_POSTER_9",385,606,377,598)
	system.notify_region_entered(region="REGION_POSTER_9",partyid="UISPIELER" )
	system.add_region("REGION_POSTER_10",379,591,371,583)
	system.notify_region_entered(region="REGION_POSTER_10",partyid="UISPIELER" )
	system.add_region("REGION_POSTER_11",231,629,223,621)
	system.notify_region_entered(region="REGION_POSTER_11",partyid="UISPIELER" )
	system.add_region("REGION_POSTER_12",298,771,290,763)
	system.notify_region_entered(region="REGION_POSTER_12",partyid="UISPIELER" )
	system.add_region("REGION_POSTER_13",617,651,609,643)
	system.notify_region_entered(region="REGION_POSTER_13",partyid="UISPIELER" )
	system.add_region("REGION_POSTER_14",631,665,623,657)
	system.notify_region_entered(region="REGION_POSTER_14",partyid="UISPIELER" )
	# Region um Schattenleiche
	system.add_region("REGION_SCHATTEN",576,324,570,318)
	system.notify_region_entered(region="REGION_SCHATTEN",partyid="UISPIELER")
	# Regionen Sekte
	system.add_region("REGION_RITUAL",688,673,740,605)
	system.add_region("REGION_RITUAL_2",710,656,725,628)
	system.add_region("REGION_OLIVIA_1",710,633,724,647)
	# Hummer
	system.add_region("REGION_HUMMER",490,735,530,780)
	system.notify_region_entered(region="REGION_HUMMER",partyid="UISPIELER")
	# Schrottplatz
	system.add_region("REGION_SCHROTT",275,660,226,612)
	system.notify_region_entered(region="REGION_SCHROTT",partyid="UISPIELER" )

	# Pickup im RS Lager
	system.add_region("REGION_PICKUP",643.54,349.62,631.64,331.48)
	system.notify_region_entered(region="REGION_PICKUP", partyid="UISPIELER" )
	
	# minenfelder
	system.add_region("REGION_MINES_1",622.5,412.0,642.0,437.0)
	system.add_region("REGION_MINES_2",603.0,412.0,485.0,425.0)
	system.add_region("REGION_MINES_3",485.0,412.0,495.0,326.0)
	system.add_region("REGION_MINES_4",498.0,303.0,489.0,270.0)
	system.notify_region_entered(region="REGION_MINES_1",partyid="UISPIELER", permanent=True)
	system.notify_region_entered(region="REGION_MINES_2",partyid="UISPIELER", permanent=True)
	system.notify_region_entered(region="REGION_MINES_3",partyid="UISPIELER", permanent=True)
	system.notify_region_entered(region="REGION_MINES_4",partyid="UISPIELER", permanent=True)	
	system.add_region("REGION_RECRUITMENT_PLACE",248,772,237,784)
	system.notify_region_entered(region="REGION_RECRUITMENT_PLACE",partyid="UISPIELER", permanent=True)

	# Dans Famous House of Drugs
	system.add_region("WorldofDrugs",635,397,594,372)
	system.notify_region_entered(region="WorldofDrugs",objectid="ALTER_EGO")


## wesley approaches player on first zone enter
def setWesleyBegruessung():
	d = [0,0]
	enter_direction = system.zone_transfer_get_direction()
	#print ">>> enter_direction=",str(enter_direction)
	pos = objects.get_position("ALTER_EGO")
#	if (enter_direction == "NORTH"):
#	pos = [(pos[0]+2),(pos[1]+3),pos[2]]
#	d = [0.5,1.5]
#	elif (enter_direction == "SOUTH"):
	pos = [(pos[0]-2),(pos[1]-3),pos[2]]
	d = [-0.5,-1.5] 
#	elif (enter_direction == "WEST"):
#		pos = [(pos[0]-3),(pos[1]-2),pos[2]]
#		d = [-1.5,-0.5]
#	else: #"EAST"
#		pos = [(pos[0]+3),(pos[1]+2),pos[2]]
#		d = [1.5,0.5]
	pos_aim = [(pos[0]-d[0]),(pos[1]-d[1])]
	objects.cancel_commandos("WESLEY")
	#print ">>> pos von wesley, setposition:",str(pos)
	objects.set_position("WESLEY",pos[0],pos[1])
	
	d = [(0-(2*d[0])),(0-(2*d[1]))]
	#print ">>> dx, dy =",str(d[0]),str(d[1])
	init_party_for_cutscene(dx=d[0],dy=d[1])
	
	objects.turn_to_object("WESLEY","ALTER_EGO", callback=["ONEND",Lambda('system.start_cutscene(); set_conversation("ALTER_EGO", cam_x=%s, cam_y=%s, mode="far_up", animate=False, new_camera=True)'%(str((3*d[0])),str((3*d[1]))))])
	#print ">>> pos von wesley, moveto:",str(pos_aim)
	objects.move_to("WESLEY",pos_aim[0],pos_aim[1],grid="landscape",speed=MT_SLOW,callback=["ONEND",Lambda('dialogs.initCutscene_061_WesleyHatEinenGutenTipp()')])
	objects.turn_to_object("ALTER_EGO","WESLEY")

## patrick the seeker makes his turn, if player approaches him, he stops
def setPatrickPouting():
	system.notify_timer(data().Timer_PatrickAufhalten,data().Timervalue_PatrickAufhalten)
	for p in ROUTE_PATRICK:
		if not (p == ROUTE_PATRICK[len(ROUTE_PATRICK)-1]):
			objects.move_to("PATRICK",p[0],p[1],"landscape",MT_SLOW)
		else:
			objects.move_to("PATRICK",p[0],p[1],"landscape",MT_SLOW, callback=["ONEND",deactivate])

## init of water ressources
def initWaterResources():
	water.set_water_source(274.4,819.3, 4)
	water.set_water_source(267.2,660.1, 3)
	water.set_water_source(424.6,456.0, 2)

def on_post_load():
	initFX()
	schedules.init_schedules()
	init_patch()

def on_map_reentry():
	initFX()
	# place vehicles
	location = GetZoneEnterLocationVehicles( system.zone_transfer_get_direction() )
	system.zone_transfer_place_vehicles( location[0], location[1] )
	location = GetZoneEnterLocation( system.zone_transfer_get_direction() )
	system.zone_transfer_place_characters( location[0], location[1] )

	if was_zone_entered("zzone_3.zzone_3"):
		if hasattr(data("zzone_3.zone_3"), 'Siebenseele_geht_zur_stadt'):
			if data("zzone_3.zone_3").Siebenseele_geht_zur_stadt:
				if "MERCENARY_SEVENSOULS" in system.get_npcs():
					objects.set_active_state("MERCENARY_SEVENSOULS",ACTIVE)
	else:
		if "MERCENARY_SEVENSOULS" in system.get_npcs():
			objects.set_active_state("MERCENARY_SEVENSOULS",INACTIVE)

	if 'WESLEY' in system.get_npcs():
		objects.set_active_state("WESLEY",INACTIVE)
		
	if 'PATRICK' in system.get_npcs():
		if (data().kill_wasser == 20 and data().kill_vorposten >= 9 and data().ratstod == 0):
			objects.set_active_state("PATRICK",INACTIVE)
	init_non_rest_areas()
	schedules.init_schedules() 
	init_patch()
	if hasattr(data('zone_8.zone_8'),'BruchMitHayes') and data('zone_8.zone_8').BruchMitHayes and not data().Bruch_Mit_Hayes:
		data().Bruch_Mit_Hayes = True


def pre_examine_object( character_id, object_id ):
	# geiselkäfig
	if object_id != None:
		if (object_id.endswith("BUILDING_249")):
			objects.set_attribute(object_id, "on_examine_coordinates",[607.7, 336.9,0])

# Kaefige bei Versuchsstation
def can_examine_object( character_id, object_id ):
	if object_id == "Z5 PICKUP":
		return not data().player_found_pickup
	
	#found_kaefig = False
	#for sstring in ["BUILDING_252","BUILDING_253", 
	#		"BUILDING_254","BUILDING_255",
	#		"BUILDING_256","BUILDING_257",
	#		"BUILDING_258","BUILDING_259"]:
	#	if object_id.endswith(sstring):
	#		found_kaefig = True
	#		break;
	#if found_kaefig:
	#	return True
	
	found_schrott = False
	for sstring in OBJ_MUSTAFA_SCHROTT:
		if object_id.endswith(sstring):
			found_schrott = True
			break;
	if found_schrott:
		return True	
	return False

def on_examine_object( character_id, object_id ):
	if object_id == "Z5 PICKUP":
		if character_id == "ALTER_EGO":
			if not data().player_found_pickup:
				data().player_found_pickup = True
				dialogs.initDlg_084_SpielerFindetEinenPickUp()
			
	#found_kaefig = False
	#for sstring in ["BUILDING_252","BUILDING_253", 
	#		"BUILDING_254","BUILDING_255",
	#		"BUILDING_256","BUILDING_257",
	#		"BUILDING_258","BUILDING_259"]:
	#	if object_id.endswith(sstring):
	#		found_kaefig = True
	#		break;
	#if found_kaefig:
	#	dialogs.initDlg_035_SpielerUntersuchtKaefige()

	if object_id != None:
		if (object_id.endswith("BUILDING_249")):
			objects.turn_to_direction(character_id, DIR_EAST)
		
	if not objects.is_destroyed("MUSTAFA"):
		found_schrott = False
		for sstring in OBJ_MUSTAFA_SCHROTT:
			if object_id.endswith(sstring):
				found_schrott = True
				break;
		if found_schrott:
			if (not system.get_qb_entry_state(data().QB_004) == COMPLETE):
				if not data().SPIELER_VORGEWARNT:
					dialogs.initDlg_042_Spieler_Aufheben1()
				else:
					dialogs.initDlg_043_Spieler_Aufheben2()
			else:
				inventorylist = objects.get_inventory_list(object_id)
				if inventorylist:
					#show object inventory
					system.item_panel( character_id, object_id )
				else:
					return False
	if objects.is_destroyed("MUSTAFA"):
		inventorylist = objects.get_inventory_list(object_id)
		if inventorylist:
			#show object inventory
			system.item_panel( character_id, object_id )
		else:
			return False
	return False
				
# Patrolien im Lager
def Patrol1(id):
	if objects.get_distance("ALTER_EGO", "RATSKULL_P_1") > 40:
		if not data().TorpostenTod:
			objects.move_to("RATSKULL_P_1",638,282, "landscape",MT_SLOW ,["ONEND",Patrol1a])
		else:
			objects.move_to("RATSKULL_P_1",638,282, "landscape",MT_FAST ,["ONEND",Patrol1a])
	else:
		objects.set_attribute( "RATSKULL_P_1", attribute="foes", value= ["UISPIELER"])
		objects.attack("RATSKULL_P_1","ALTER_EGO")

def Patrol1a(id):
	if objects.get_distance("ALTER_EGO", "RATSKULL_P_1") > 40:
		if not data().TorpostenTod:
			objects.move_to("RATSKULL_P_1",637,390, "landscape",MT_SLOW ,["ONEND",Patrol1])
		else:
			objects.move_to("RATSKULL_P_1",637,390, "landscape",MT_FAST ,["ONEND",Patrol1])
	else:
		objects.set_attribute( "RATSKULL_P_1", attribute="foes", value= ["UISPIELER"])
		objects.attack("RATSKULL_P_1","ALTER_EGO")

def Patrol2(id):
	if objects.get_distance("ALTER_EGO", "RATSKULL_P_2") > 40:
		if not data().TorpostenTod:
			objects.move_to("RATSKULL_P_2",638,398, "landscape",MT_SLOW ,["ONEND",Patrol2a])
		else:
			objects.move_to("RATSKULL_P_2",638,398, "landscape",MT_FAST ,["ONEND",Patrol2a])
	else:
		objects.set_attribute( "RATSKULL_P_2", attribute="foes", value=["UISPIELER"])
		objects.attack("RATSKULL_P_2","ALTER_EGO")

def Patrol2a(id):
	if objects.get_distance("ALTER_EGO", "RATSKULL_P_2") > 40:
		if not data().TorpostenTod:
			objects.move_to("RATSKULL_P_2",512,403, "landscape",MT_SLOW ,["ONEND",Patrol2])
		else:
			objects.move_to("RATSKULL_P_2",512,403, "landscape",MT_FAST ,["ONEND",Patrol2])
	else:
		objects.set_attribute( "RATSKULL_P_2", attribute="foes", value=["UISPIELER"])
		objects.attack("RATSKULL_P_2","ALTER_EGO")

def Patrol3(id):
	if objects.get_distance("ALTER_EGO", "RATSKULL_P_3") > 40:
		if not data().TorpostenTod:
			objects.move_to("RATSKULL_P_3",509,403, "landscape",MT_SLOW ,["ONEND",Patrol3a])
		else:
			objects.move_to("RATSKULL_P_3",509,403, "landscape",MT_FAST ,["ONEND",Patrol3a])
	else:
		objects.set_attribute( "RATSKULL_P_3", attribute="foes", value=["UISPIELER"])
		objects.attack("RATSKULL_P_3","ALTER_EGO")

def Patrol3a(id):
	if objects.get_distance("ALTER_EGO", "RATSKULL_P_3") > 40:
		if not data().TorpostenTod:
			objects.move_to("RATSKULL_P_3",510,330, "landscape",MT_SLOW ,["ONEND",Patrol3b])
		else:
			objects.move_to("RATSKULL_P_3",510,330, "landscape",MT_FAST ,["ONEND",Patrol3b])
	else:
		objects.set_attribute( "RATSKULL_P_3", attribute="foes", value=["UISPIELER"])
		objects.attack("RATSKULL_P_3","ALTER_EGO")

def Patrol3b(id):
	if objects.get_distance("ALTER_EGO", "RATSKULL_P_3") > 40:
		if not data().TorpostenTod:
			objects.move_to("RATSKULL_P_3",520,294, "landscape",MT_SLOW ,["ONEND",Patrol3c])
		else:
			objects.move_to("RATSKULL_P_3",520,294, "landscape",MT_FAST ,["ONEND",Patrol3c])
	else:
		objects.set_attribute( "RATSKULL_P_3", attribute="foes", value=["UISPIELER"])
		objects.attack("RATSKULL_P_3","ALTER_EGO")

def Patrol3c(id):
	if objects.get_distance("ALTER_EGO", "RATSKULL_P_3") > 40:
		if not data().TorpostenTod:
			objects.move_to("RATSKULL_P_3",510,330, "landscape",MT_SLOW ,["ONEND",Patrol3])
		else:
			objects.move_to("RATSKULL_P_3",510,330, "landscape",MT_FAST ,["ONEND",Patrol3])
	else:
		objects.set_attribute( "RATSKULL_P_3", attribute="foes", value=["UISPIELER"])
		objects.attack("RATSKULL_P_3","ALTER_EGO")

def Patrol4(id):
	if objects.get_distance("ALTER_EGO", "RATSKULL_P_4") > 40:
		if not data().TorpostenTod:
			objects.move_to("RATSKULL_P_4",516,291, "landscape",MT_SLOW ,["ONEND",Patrol4a])
		else:
			objects.move_to("RATSKULL_P_4",516,291, "landscape",MT_FAST ,["ONEND",Patrol4a])
	else:
		objects.set_attribute( "RATSKULL_P_4", attribute="foes", value=["UISPIELER"])
		objects.attack("RATSKULL_P_4","ALTER_EGO")

def Patrol4a(id):
	if objects.get_distance("ALTER_EGO", "RATSKULL_P_4") > 40:
		if not data().TorpostenTod:
			objects.move_to("RATSKULL_P_4",624,290, "landscape",MT_SLOW ,["ONEND",Patrol4])
		else:
			objects.move_to("RATSKULL_P_4",624,290, "landscape",MT_FAST ,["ONEND",Patrol4])
	else:
		objects.set_attribute( "RATSKULL_P_4", attribute="foes", value=["UISPIELER"])
		objects.attack("RATSKULL_P_4","ALTER_EGO")
def Familie_in_Zone3_bringen(id):
	data("zone_3.zone_3").ian_linda_paula_folgen = True
	if not data("zone_5.zone_5").family_ready_for_zonetransfer:
		data("zone_5.zone_5").Familie_wird_Eskortiert = True
		for member in NPC_FAMILY:
			objects.set_attribute(member,"zone_transfer",True)
			objects.set_attribute(member,"zone_transfer_new_party","NPCS")
			allow_activity(member)
		data("zone_5.zone_5").family_ready_for_zonetransfer = True

def on_approach(target, operator):
	if not object_events.on_approach(target, operator):
		dialogs.on_approach(target, operator)

def on_trade(target,operator):
	if not object_events.on_trade(target,operator):
		return False
	if target=="DAMIEN":
		objects.cancel_commandos(target)
		if get_location("HAENDLER") == 1:
			prohibit_activity(target)
		lambda_string = 'system.trading_screen(trader="%s",char="%s")' %(target,operator)
		objects.turn_to_object(target, operator, callback=["ONEND", Lambda(lambda_string)])
	return None

def on_exit_trader( trader_id, negotiator_id, profit ):
	allow_activity(trader_id)
	return object_events.on_exit_trader( trader_id, negotiator_id, profit)
	
def on_wait_for_commando(id):
	if id == "OLIVIA" and not data().Olivia_frei:
		character.play_animation("OLIVIA", "CM_NPC_STEHEN_OPFERUNG_OPFER_GESTE")
		return True
	else:
		#return True
		return schedules.Activity(id)

def initExitZones():
	system.add_region( id = "REGION_EXIT_NORD", x1 = 0.00, y1 = 210.00, x2 = 798.00, y2 = 0.00 )
	system.register_exit(regionname = "REGION_EXIT_NORD")
	system.add_region( id = "REGION_EXIT_SUED", x1 = 0.00, y1 = 1100.00, x2 = 1031.00, y2 = 854.00 )
	system.register_exit(regionname = "REGION_EXIT_SUED")
	system.add_region( id = "REGION_EXIT_WEST", x1 = 0.00, y1 = 854.00, x2 = 206.00, y2 = 210.00 )
	system.register_exit(regionname = "REGION_EXIT_WEST")
	system.add_region( id = "REGION_EXIT_OST", x1 = 798.00, y1 = 854.00, x2 = 1050.00, y2 = 0.00 )
	system.register_exit(regionname = "REGION_EXIT_OST")

# Bewaffnung
def initItems():
	if not hasattr(data(), "patch_patrick"):
		data().patch_patrick = True
	
	objects.create_item_in_inventory( object="DAMIEN",
		equipment=[
			"SET_TENT_CANVAS",# tent_canvas
			"SET_WATER_DETECTOR",# water_detector
			"SET_BREAD","SET_BREAD",# 2 bread
			"SET_CORN_COB",# 5 corn_cob
			"SET_CORN_COB",
			"SET_CORN_COB",
			"SET_CORN_COB",
			"SET_CORN_COB",
			"SET_CHEESE",# 2 cheese
			"SET_CHEESE",
			"SET_WATER_SKIN",# 5 water_skin
			"SET_WATER_SKIN",
			"SET_WATER_SKIN",
			"SET_WATER_SKIN",
			"SET_WATER_SKIN",
			"SET_WATER_CAN",# Water_can
			"SET_BASIC_PICKLOCK",# 2 basic_picklock
			"SET_BASIC_PICKLOCK",
			"SET_SET_OF_PICKLOCKS",# set_of_picklocks
			"SET_MEDIPACK_SMALL",# 3 medipack_small
			"SET_MEDIPACK_SMALL",
			"SET_MEDIPACK_SMALL",
			"SET_MEDIPACK_BIG",# medipack_big
			"SET_DRUGS_PILLS_03",# stimulant_drug
			"SET_DRUGS_PILLS_01",# drugs_pills_01
			"SET_DRUGS_PILLS_02",# drugs_pills_02
			"SET_DRUGS_VIALS_02",# drugs_vials_02
			"SET_DRUGS_SYRINGE",# drugs_syringe
			"SET_OINTMANT_JAR",# ointment_jar
			"SET_OINTMANT_JAR",
			"SET_OINTMANT_JAR",
			"SET_GUN_POWDER",
			"SET_GUN_POWDER",
			"SET_COAL_PILLS",
			"SET_GAS_CANISTER"]# Benzinkanister
			)

	objects.create_item_in_inventory( object="DAMIEN",
		equipment=[
			"SET_MP5",# MP5
			"SET_HK_UMP_45",# HK UMP 45
			"SET_AUTOMAG_3",# Automag 3
			"SET_RPK_74",# RPK
			"SET_HK_G41",# G 41
			"SET_FN_MAG",# FN MAG
			"SET_AK_47",# AK-47
			"SET_M_79",# M-79
			"SET_CROSSBOW",# Armbrust
			"SET_AMMOPACK_BOLT"]# 1 Packen Armbrustbolzen
			+3*["SET_AMMOPACK_2_12_MM_QB_8"]# 3 Packen 2“12Cal qb8
			+5*["SET_AMMOPACK_2_12_MM"]# 5 Packen 2“12Cal
			+3*["SET_AMMOPACK_50_AE_DUMDUM"]# 3 Packen .50AE Munition
			+9*["SET_AMMOPACK_9_MM"]# 9 Packen 9mm Munition
			+3*["SET_AMMOPACK_9_MM_SUBSONIC"]# 3 Packen 9mm Subsonicmunition
			+4*["SET_AMMOPACK_44"]# 4 Packen .44er Munition
			+6*["SET_AMMOPACK_45"]# 6 Packen .45er Munition
			+3*["SET_AMMOPACK_45_SUBSONIC"]# 3 Packen .45er Subsonicmunition
			+9*["SET_AMMOPACK_7_62NATO_MM"]# 9 Packen 7,62x51 nato Munition
			+8*["SET_AMMOPACK_7_62NATO_MM_SABOT"]# 8 Packen 7,62x51 nato Sabot
			+8*["SET_AMMOPACK_7_62SOVJET_MM"]# 8 Packen 7,62x39 sovjet Munition
			+7*["SET_AMMOPACK_5_56_MM"]# 7 Packen 5,56mm Munition
			+2*["SET_AMMOPACK_357_SUBSONIC"]# 2 Packen .357Sig Subsonicmunition
			+6*["SET_AMMOPACK_5_45_MM"]# 6 Packen 5,45mm Munition
			+3*["SET_AMMOPACK_M79_M203"]# 3 Packen 40mm HE-Granaten für M79 und M203 zusätzlich
			+6*["SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE"]# 6 Packen 5,56mm Munition Steyr Flechette
			+["SET_CHAIN_SAW",# Kettensäge
			"SET_C4_TIMEBASED",# Dynamit mit Zeitzünder
			"SET_DT21_GAUNTLETS",# dt21 Panzerhandschuhe
			"SET_DT21_STEEL_CLAD_BOOTS",# dt21 Panzerstiefel
			"SET_PAN",
			"SET_SPIT"])

	objects.create_item_in_inventory( object="RATSKULL_V1_1",equipment=["SET_COLT_45","SET_AMMOPACK_45"])
	objects.create_item_in_inventory( object="RATSKULL_V1_2",equipment=["SET_DESERT_EAGLE","SET_AMMOPACK_50"])
	objects.create_item_in_inventory( object="RATSKULL_V1_3",equipment=["SET_REMINGTON_M870","SET_AMMOPACK_2_12_MM","SET_AMMOPACK_2_12_MM"])
	objects.create_item_in_inventory( object="RATSKULL_V1_4",equipment=["SET_REMINGTON_M870","SET_AMMOPACK_2_12_MM"])
	objects.create_item_in_inventory( object="RATSKULL_V2_1",equipment=["SET_M_16","SET_AMMOPACK_5_56_MM"])
	objects.create_item_in_inventory( object="RATSKULL_V2_2",equipment=["SET_DESERT_EAGLE","SET_AMMOPACK_50"])
	objects.create_item_in_inventory( object="RATSKULL_V3_1",equipment=["SET_REMINGTON_M870","SET_AMMOPACK_2_12_MM","SET_AMMOPACK_2_12_MM"])
	objects.create_item_in_inventory( object="RATSKULL_V3_2",equipment=["SET_COLT_45","SET_AMMOPACK_45"])
	objects.create_item_in_inventory( object="RATSKULL_V3_3",equipment=["SET_DESERT_EAGLE","SET_AMMOPACK_50"])
	objects.create_item_in_inventory( object="RATSKULL_V3_4",equipment=["SET_DESERT_EAGLE","SET_AMMOPACK_50"])
	objects.create_item_in_inventory( object="RATSKULL_V4_1",equipment=["SET_AKSU74","SET_AMMOPACK_5_45_MM"])
	objects.create_item_in_inventory( object="RATSKULL_V4_2",equipment=["SET_UZI"])
	objects.create_item_in_inventory( object="RATSKULL_V4_3",equipment=["SET_REMINGTON_M870","SET_AMMOPACK_2_12_MM"])
	objects.create_item_in_inventory( object="RATSKULL_TW_1",equipment=["SET_M_79","SET_AMMOPACK_M79_M203"])
	objects.create_item_in_inventory( object="RATSKULL_TP_1",equipment=["SET_M_16","SET_AMMOPACK_5_56_MM"])
	objects.create_item_in_inventory( object="RATSKULL_TP_2",equipment=["SET_REMINGTON_M870","SET_AMMOPACK_2_12_MM"])
	objects.create_item_in_inventory( object="RATSKULL_TP_3",equipment=["SET_REMINGTON_M870","SET_AMMOPACK_2_12_MM"])
	objects.create_item_in_inventory( object="RATSKULL_P_1",equipment=["SET_UZI","SET_AMMOPACK_9_MM"])
	objects.create_item_in_inventory( object="RATSKULL_P_2",equipment=["SET_UZI","SET_AMMOPACK_9_MM"])
	objects.create_item_in_inventory( object="RATSKULL_P_3",equipment=["SET_UZI","SET_AMMOPACK_9_MM"])
	objects.create_item_in_inventory( object="RATSKULL_P_4",equipment=["SET_UZI"])
	objects.create_item_in_inventory( object="RATSKULL_WT_1",equipment=["SET_MICRO_UZI","SET_AMMOPACK_9_MM"])
	objects.create_item_in_inventory( object="RATSKULL_WT_2",equipment=["SET_MICRO_UZI","SET_AMMOPACK_9_MM"])
	objects.create_item_in_inventory( object="RATSKULL_WT_3",equipment=["SET_SPECIAL_38","SET_AMMOPACK_38"])
	objects.create_item_in_inventory( object="RATSKULL_R_1",equipment=["SET_UZI"])
	objects.create_item_in_inventory( object="RATSKULL_R_2",equipment=["SET_MICRO_UZI","SET_AMMOPACK_9_MM"])
	objects.create_item_in_inventory( object="RATSKULL_R_3",equipment=["SET_MICRO_UZI","SET_AMMOPACK_9_MM"])
	objects.create_item_in_inventory( object="RATSKULL_R_4",equipment=["SET_SIG_SAUER","SET_AMMOPACK_357"])
	objects.create_item_in_inventory( object="RATSKULL_R_5",equipment=["SET_SIG_SAUER","SET_AMMOPACK_357"])
	objects.create_item_in_inventory( object="RATSKULL_R_6",equipment=["SET_UZI","SET_AMMOPACK_9_MM"])
	objects.create_item_in_inventory( object="RATSKULL_R_7",equipment=["SET_UZI"])
	objects.create_item_in_inventory( object="RATSKULL_R_8",equipment=["SET_COLT_45","SET_AMMOPACK_45"])
	objects.create_item_in_inventory( object="RATSKULL_R_9",equipment=["SET_DESERT_EAGLE","SET_AMMOPACK_50"])
	objects.create_item_in_inventory( object="PHOENIX",equipment=["SET_DESERT_EAGLE","SET_AMMOPACK_50"])

# Rowdies
	objects.create_item_in_inventory( object="BRANDON",equipment=["SET_COLT_45","SET_AMMOPACK_45"])
	objects.create_item_in_inventory( object="SCHLAEGER_1",equipment=["SET_SPECIAL_38","SET_AMMOPACK_38"])
	objects.create_item_in_inventory( object="SCHLAEGER_2",equipment=["SET_SPECIAL_38","SET_AMMOPACK_38"])
	objects.create_item_in_inventory( object="SCHLAEGER_3",equipment=["SET_COLT_45","SET_AMMOPACK_45"])

# Schrottplatz
	objects.create_item_in_inventory( object="MUSTAFA",equipment=["SET_COLT_45","SET_AMMOPACK_45"])
	objects.create_item_in_inventory( object="MEHMET",equipment=["SET_SPECIAL_38","SET_AMMOPACK_38"])
	objects.create_item_in_inventory( object="ALI",equipment=["SET_SPECIAL_38","SET_AMMOPACK_38"])
	objects.create_item_in_inventory("BUILDING_427",["SET_RAT_MEAT","SET_HAIRSTYLE_MAGAZINE"])
	#objects.create_item_in_inventory("BUILDING_2454",["SET_SMOKEGRENADE"])
	objects.create_item_in_inventory("BUILDING_420",["SET_MULTI_MEDIPACK"])
	objects.create_item_in_inventory("BUILDING_2453",["SET_MULTI_MEDIPACK"])
	objects.create_item_in_inventory("BUILDING_3108",["SET_RAT_MEAT","SET_MULTI_MEDIPACK"])

# Oberguru
	objects.create_item_in_inventory( object="TIZOC",equipment=["SET_SPECIAL_38","SET_AMMOPACK_38"])

# Sekte
	objects.create_item_in_inventory( object="SECT_PRIEST",equipment=["SET_SPECIAL_38","SET_AMMOPACK_38"])#"SET_KNIFE"])
	objects.create_item_in_inventory( object="SEKTE_1",equipment=["SET_SPECIAL_38","SET_AMMOPACK_38"])
	objects.create_item_in_inventory( object="SEKTE_2",equipment=["SET_SPECIAL_38","SET_AMMOPACK_38"])
	objects.create_item_in_inventory( object="SEKTE_3",equipment=["SET_SPECIAL_38","SET_AMMOPACK_38"])
	objects.create_item_in_inventory( object="SEKTE_4",equipment=["SET_SPECIAL_38","SET_AMMOPACK_38"])
	objects.create_item_in_inventory( object="SEKTE_5",equipment=["SET_SPECIAL_38","SET_AMMOPACK_38"])
	objects.create_item_in_inventory( object="SECTARIAN",equipment=["SET_SPECIAL_38","SET_AMMOPACK_38"])

	character.equip("RATSKULL_V1_1", equipment="SET_COLT_45")
	character.equip("RATSKULL_V1_2", equipment="SET_DESERT_EAGLE")
	character.equip("RATSKULL_V1_3", equipment="SET_REMINGTON_M870")
	character.equip("RATSKULL_V1_4", equipment="SET_REMINGTON_M870")
	character.equip("RATSKULL_V2_1", equipment="SET_M_16")
	character.equip("RATSKULL_V2_2", equipment="SET_DESERT_EAGLE")
	character.equip("RATSKULL_V3_1", equipment="SET_REMINGTON_M870")
	character.equip("RATSKULL_V3_2", equipment="SET_COLT_45")
	character.equip("RATSKULL_V3_3", equipment="SET_DESERT_EAGLE")
	character.equip("RATSKULL_V3_4", equipment="SET_DESERT_EAGLE")
	character.equip("RATSKULL_V4_1", equipment="SET_AKSU74")
	character.equip("RATSKULL_V4_2", equipment="SET_UZI")
	character.equip("RATSKULL_V4_3", equipment="SET_REMINGTON_M870")
	character.equip("RATSKULL_TW_1", equipment="SET_M_79")
	character.equip("RATSKULL_TP_1", equipment="SET_M_16")
	character.equip("RATSKULL_TP_2", equipment="SET_REMINGTON_M870")
	character.equip("RATSKULL_TP_3", equipment="SET_REMINGTON_M870")
	character.equip("RATSKULL_P_1", equipment="SET_UZI")
	character.equip("RATSKULL_P_2", equipment="SET_UZI")
	character.equip("RATSKULL_P_3", equipment="SET_UZI")
	character.equip("RATSKULL_P_4", equipment="SET_UZI")
	character.equip("RATSKULL_WT_1", equipment="SET_MICRO_UZI")
	character.equip("RATSKULL_WT_2", equipment="SET_MICRO_UZI")
	character.equip("RATSKULL_WT_3", equipment="SET_SPECIAL_38")
	character.equip("RATSKULL_R_1", equipment="SET_UZI")
	character.equip("RATSKULL_R_2", equipment="SET_MICRO_UZI")
	character.equip("RATSKULL_R_3", equipment="SET_MICRO_UZI")
	character.equip("RATSKULL_R_4", equipment="SET_SIG_SAUER")
	character.equip("RATSKULL_R_5", equipment="SET_SIG_SAUER")
	character.equip("RATSKULL_R_6", equipment="SET_UZI")
	character.equip("RATSKULL_R_7", equipment="SET_UZI")
	character.equip("RATSKULL_R_8", equipment="SET_COLT_45")
	character.equip("RATSKULL_R_9", equipment="SET_DESERT_EAGLE")
	character.equip("PHOENIX", equipment="SET_DESERT_EAGLE")

	# Flugblaetter
	positions = [	[352,646],[229,713],[239,660],[242,767],[329,782],
			[340,740],[345,716],[346,615],[381,602],[375,587],
			[227,625],[294,767],[613,647],[627,661]]
	
	for i in range(0,13):
		pos = positions[i]
		poster_id = QI_POSTER[1]+"_"+str(i)
		system.create_object(	equipmenttype=QI_POSTER[0],
					x=pos[0],y=pos[1],
					direction=random.randint(0,360),
					id=poster_id)
		objects.set_attribute(	object=poster_id, 
					attribute="generic_item",
					value=False)

	# Solarzelle
	for i in range(1,4):
		solarzelle = QI_SOLARZELLE[1]+"_"+str(i)
		if i == 1:
			system.create_object(equipmenttype=QI_SOLARZELLE[0],x=241,y=627.50,direction=0, id = solarzelle)
		elif i == 2:
			objects.create_item_in_inventory("BUILDING_2228",QI_SOLARZELLE[0],solarzelle)
		elif i == 3:
			objects.create_item_in_inventory("BUILDING_2662",QI_SOLARZELLE[0],solarzelle)
	
		objects.set_attribute(object=solarzelle, attribute="generic_item", value=False)

	#lager der ratskulls
	objects.create_item_in_inventory("BUILDING_1794",["SET_NORMAL_CLOTHES_4","SET_LEATHER_BOOTS"])
	objects.create_item_in_inventory("BUILDING_1791",["SET_TIGER_FUR"])
	objects.create_item_in_inventory("BUILDING_1233",['SET_SIG_SAUER_W_SILENCER',  'SET_MOLOTOV_COCKTAIL', "SET_AMMOPACK_7_62NATO_MM"])
	objects.create_item_in_inventory("BUILDING_1232",["SET_DRUGS_PILLS_02"])
	objects.create_item_in_inventory("BUILDING_1226",["SET_BOTTLE_OF_WHISKEY"])
	objects.create_item_in_inventory("BUILDING_1228",["SET_GRAINS"])
	objects.create_item_in_inventory("BUILDING_1260",["SET_RAT_MEAT"])
	objects.create_item_in_inventory("BUILDING_1236",["SET_GUN_POWDER","SET_FRAGGRENADE","SET_HEGRENADE"])
	objects.create_item_in_inventory("BUILDING_1063",["SET_HK_USP_45","SET_AMMOPACK_45","SET_AMMOPACK_45"])
	objects.create_item_in_inventory("BUILDING_1744",["SET_SMALL_PICTURE_FRAME"])
	objects.create_item_in_inventory("BUILDING_1061",["SET_WATER_SKIN"])
	objects.create_item_in_inventory("BUILDING_1052",["SET_MEAT_RAW_HUMONGOUS"])
	objects.create_item_in_inventory("BUILDING_1746",["SET_BROKEN_POCKET_CALCULATOR"])
	## aussenbereich des lagers
	objects.create_item_in_inventory("BUILDING_1641",["SET_LOW_SHOES","SET_PROTECTIVE_GLOVES"])
	objects.create_item_in_inventory("BUILDING_867",["SET_WATER_BOTTLE"])
	objects.create_item_in_inventory("BUILDING_1796",["SET_STEEL_HELMET","SET_MEDIPACK_SMALL"])
	## kleines dorf
	#objects.create_item_in_inventory("BUILDING_2657",["SET_RED_SHARD"])
	objects.create_item_in_inventory("BUILDING_2660",["SET_WATER_BOTTLE"])
	objects.create_item_in_inventory("BUILDING_2549",["SET_NORMAL_CLOTHES_4"])
	
	#müllsack
	objects.create_item_in_inventory("BUILDING_3232",["SET_RAGS"])
	#hundehütte
	objects.create_item_in_inventory("BUILDING_2554",["SET_BASEBALL_BAT"])
	#ruine an der strasse
	objects.create_item_in_inventory("BUILDING_12507",["SET_WOODEN_BOARD","SET_SHORT_NAILS"])
	#wäscheleine
	objects.create_item_in_inventory("BUILDING_2037",["SET_NORMAL_CLOTHES_4"])
	#klo
	objects.create_item_in_inventory("BUILDING_3317",["SET_THROWING_KNIFE"])
	#tisch mit tonkrügen
	objects.create_item_in_inventory("BUILDING_2044",["SET_BRASS_KNUCKLES"])
	#kistenstapel homehardwarestore
	objects.create_item_in_inventory("BUILDING_12561",["SET_GUN_POWDER","SET_AXE"])
	#autowrack
	objects.create_item_in_inventory("BUILDING_2428",["SET_CLUB"])
	
	# Stahlregal
	objects.create_item_in_inventory(object="BUILDING_13263",equipment=["SET_HEADPHONE"])
	# Holzkommode
	objects.create_item_in_inventory(object="BUILDING_13179",equipment=["SET_HK_UMP_45_W_LASERPOINTER"])
	# Spind
	objects.create_item_in_inventory(object="BUILDING_13189",equipment=["SET_THROWING_KNIFE"])
	# Holzkommode
	objects.create_item_in_inventory(object="BUILDING_13164",equipment=["SET_GUN_POWDER","SET_AMMOPACK_4_73_CASELESS"])
	# Kommode
	objects.create_item_in_inventory(object="BUILDING_13151",equipment=["SET_RUSTY_IRON_ROD"])
	# Anhänger
	objects.create_item_in_inventory(object="BUILDING_2852",equipment=["SET_SIMONOV_SKS"])
	# Spülbecken
	objects.create_item_in_inventory(object="BUILDING_13134",equipment=["SET_DT21_STEEL_CLAD_HELMET"])
	# Schrottauto
	objects.create_item_in_inventory(object="BUILDING_3101",equipment=["SET_WATERING_CAN"])
	# Schaufeltruck
	objects.create_item_in_inventory(object="BUILDING_2174",equipment=["SET_SHURIKEN"])
	# Bett
	objects.create_item_in_inventory(object="BUILDING_13368",equipment=["SET_C4_REMOTE_CONTROL"])
	# Sandkasten
	objects.create_item_in_inventory(object="BUILDING_2650",equipment=["SET_WATER_SKIN"])
	# Tisch
	objects.create_item_in_inventory(object="BUILDING_12662",equipment=["SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE"])
	# Kisten
	objects.create_item_in_inventory(object="BUILDING_1015",equipment=["SET_MEDIPACK_SMALL"])
	# Metallbank
	objects.create_item_in_inventory(object="BUILDING_13042",equipment=["SET_MEAT_RAW"])
	# Autopalisade
	objects.create_item_in_inventory(object="BUILDING_954",equipment=["SET_RED_SHARD"])
	# Beistelltisch
	objects.create_item_in_inventory(object="BUILDING_12714",equipment=["SET_WATER_DETECTOR"])
	# Holzfaß
	objects.create_item_in_inventory(object="BUILDING_13087",equipment=["SET_MEDIPACK_SMALL"])
	# Kiste
	objects.create_item_in_inventory(object="BUILDING_3316",equipment=["SET_LEATHER_GLOVES"])

	
	# Bienenstöcke Z5
	objects.create_item_in_inventory( 'BUILDING_15986', equipment=[ 'SET_BEESWAX' ] )
	objects.create_item_in_inventory( 'BUILDING_15985', equipment=[ 'SET_BEESWAX', 'SET_BEESWAX' ] )
	objects.create_item_in_inventory( 'BUILDING_15984', equipment=[ 'SET_BEESWAX' ] )
	objects.create_item_in_inventory( 'BUILDING_15987', equipment=[ 'SET_BEESWAX', 'SET_BEESWAX' ] )
	# objects.create_item_in_inventory( 'BUILDING_15983', equipment=[ 'SET_BEESWAX' ] )

	# Items in Kisten
	objects.create_item_in_inventory( 'BUILDING_15828', equipment=[ 'SET_LIGHTER', 'SET_SIG_SAUER_W_SILENCER', 'SET_MOLOTOV_COCKTAIL', "SET_MG_3","SET_AMMOPACK_7_62NATO_MM","SET_AMMOPACK_7_62NATO_MM" ] )
	objects.create_item_in_inventory( 'BUILDING_15842', equipment=[ 'SET_THROWING_KNIFE', 'SET_MACHETE', 'SET_AMMOPACK_357' ] )
	objects.create_item_in_inventory( 'BUILDING_15851', equipment=[ "SET_GUN_POWDER", 'SET_AMMOPACK_50_BMG', 'SET_PLATE_ARMOR' ] )
	objects.create_item_in_inventory( 'BUILDING_15855', equipment=[ 'SET_STEEL_HELMET', 'SET_MEAT_RAW_HUMONGOUS', 'SET_WATER_CAN' ] )
	objects.create_item_in_inventory( 'BUILDING_15856', equipment=[ 'SET_MEDIPACK_BIG', 'SET_AMMOPACK_5_45_MM', 'SET_AMMOPACK_2_12_MM' ] )
	objects.create_item_in_inventory( 'BUILDING_15864', equipment=[ 'SET_PLATE_GLOVES', 'SET_AMMOPACK_45_SUBSONIC_DUMDUM', 'SET_BULLET_PROOF_CLOTHES' ] )
	objects.create_item_in_inventory( 'BUILDING_15865', equipment=[ 'SET_MANSLAYER', 'SET_AMMOPACK_9_MM_SUBSONIC' ] )
	objects.create_item_in_inventory( 'BUILDING_13681', equipment=[ 'SET_DESERT_EAGLE_W_LASERPOINTER', 'SET_DRUGS_PILLS_03', 'SET_DRUGS_PILLS_06', 'SET_DRUGS_PILLS_01', 'SET_MEDIPACK_SMALL', 'SET_MEDIPACK_BIG', 'SET_C4_TIMEBASED_W_NAILS' ] )
	objects.create_item_in_inventory( 'BUILDING_15867', equipment=[ 'SET_BASEBALL_BAT', 'SET_AMMOPACK_5_7_MM_DUMDUM' ] )
	objects.create_item_in_inventory( 'BUILDING_13258', equipment=[ 'SET_AMMOPACK_4_6_MM', 'SET_AMMOPACK_4_6_MM', 'SET_CAKE_TIN' ] )# , 'SET_MUN_LAW'
	objects.create_item_in_inventory( 'BUILDING_13517', equipment=[ 'SET_AMMOPACK_9_MM', 'SET_THROWING_KNIFE' ] )
	objects.create_item_in_inventory( 'BUILDING_15886', equipment=[ 'SET_AKSU74', 'SET_SPAS_15', 'SET_HEGRENADE' ] )
	
	# Fass
	data().patch_patrick = 2
	objects.create_item_in_inventory("BUILDING_3316",equipment=["SET_AMMOPACK_BOLT"])

	# Im Safe im Haus, nahe dem roten Dodgeram
	data().patch_patrick = 3
	objects.create_item_in_inventory( 'BUILDING_15886', 'SET_AMMOPACK_7_62_54_MMR' )

	data().patch_patrick = 4
	objects.create_item_in_inventory(object="BUILDING_13189",equipment='SET_THROWING_KNIFE' )
	objects.create_item_in_inventory(object="BUILDING_3316",equipment='SET_SHURIKEN' )
	objects.create_item_in_inventory( 'BUILDING_15828', equipment=[ 'SET_DART', 'SET_DART' ] )
	objects.create_item_in_inventory( 'BUILDING_15865', equipment= 'SET_SHURIKEN' )
	
	
def initMinimapMarkers():
	system.add_minimap_marker(571.29, 327.35,"MM_001")#Basis der Ratskulls
	
def initHerbs():
	system.create_object(equipmenttype="SET_ALOE_VERA", x=417.31, y=244.66)
	system.create_object(equipmenttype="SET_ALOE_VERA", x=730.35, y=526.36)
	system.create_object(equipmenttype="SET_ALOE_VERA", x=602.06, y=829.57)
	system.create_object(equipmenttype="SET_ALOE_VERA", x=768.26, y=756.87)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x=550.77, y=722.87)
	system.create_object(equipmenttype="SET_WOOD_GARLIC", x=779.74, y=335.66)
	system.create_object(equipmenttype="SET_BURNET", x=359.96, y=431.24)
	system.create_object(equipmenttype="SET_ANGELICA", x=764.70, y=767.41)
	
# Aufheben der Solarzelle ( muss beim versuch bleiben bis Mustafa ueberzeugt ist )
def on_pick_up( character_id, item_id, item_type ):
	if item_id.rfind(QI_SOLARZELLE[1]+"_1") != -1:
		if not data().SPIELER_VORGEWARNT and not data().Ziel4 and not data().Mustafa_Tod:
			dialogs.initDlg_042_Spieler_Aufheben1()
			return False
	
		if data().SPIELER_VORGEWARNT and not data().Ziel4 and not data().Mustafa_Tod:
			dialogs.initDlg_043_Spieler_Aufheben2()
			return False
	
		if (system.get_qb_entry_state(data().QB_001) == COMPLETE):
			return True
			
		if objects.is_destroyed("MUSTAFA"):
			return True
	
	# Flugblaetter lesen
	if (item_id.rfind(QI_POSTER[1]) != -1):
		dialogs.initDlg_023_Steckbriefe()
		data().Poster_gelesen = True
		return True
	
	# Tagebuch von Tizoc lesen
	if (item_id == QI_TAGEBUCH[1]):
		dialogs.initDlg_076_Tagebuch()
		return True
	
	return object_events.on_pick_up( character_id, item_id, item_type)

def general_watches_player(charid = None):
	if (system.get_qb_entry_state(data().QB_001) == UNCOMPLETE or
		system.get_qb_entry_state(data().QB_002) == UNCOMPLETE or
		system.get_qb_entry_state(data().QB_003) == UNCOMPLETE):
		return	
	objects.turn_to_object("GENERAL_LEWIS", data().player_at_recruitment, callback=["ONEND",general_watches_player])
	
def minefield_entered(object_list):
	if not isinstance(object_list, list):
		object_list = [object_list]
	if not len(object_list):
		return
		
	car_id = None
	for character_id in object_list:
		if character.get_vehicle_from_char(character_id):
			car_id = character.get_vehicle_from_char(character_id)
		elif not objects.is_destroyed(character_id):
			objects.destroy(character_id)
			
	if car_id:
		objects.destroy(car_id)

# Kommentar Flugblaetter
def on_enter_region(id, objectid, partyid):
	#print "[on_enter_region(",id, str(objectid), partyid,"]"
	# non-permanent triggers: objectid is list of all chars in region
	
	if id in ["REGION_MINES_1","REGION_MINES_2","REGION_MINES_3","REGION_MINES_4"]:
		minefield_entered(objectid)
		
		if isinstance(objectid,list):
			if len(objectid): objectid=objectid[0]
			else: return
		
		pcs = system.get_pcs()
		if objectid in pcs:
			#print ">>> minefield -> halt all pcs"
			for pc in system.get_pcs():
				if not objects.is_destroyed(pc):
					objects.cancel_commandos(pc)
					objects.turn_to_object(pc, objectid)
		explode(objectid, count=3, radius=0.5)
		#objects.destroy(objectid)
		system.notify_region_entered(region=id, partyid="UISPIELER")

	if isinstance(objectid,list):
		if len(objectid): objectid=objectid[0]
		else: return
	
	if id == "REGION_PICKUP":
		if not data().player_found_pickup:
			data().player_found_pickup = True
			dialogs.initDlg_084_SpielerFindetEinenPickUp()
	
	if id == "REGION_HUMMER":
		if not data().spieler_von_wesley_betrogen:
			dialogs.initCutscene_062_SpielerFindetHummer()
		else:
			dialogs.initCutscene_078_SpielerFindetHummerWesleyEnttarnt()
		if not data().player_knows_hummer:
			data().player_knows_hummer = True
			system.add_minimap_marker(516.11, 761.16,"MM_007")# Höhle mit Hummer
		
	if not data().Poster_gesehen:
		if (id in ["REGION_POSTER_1","REGION_POSTER_2","REGION_POSTER_3","REGION_POSTER_4",
			   "REGION_POSTER_5","REGION_POSTER_6","REGION_POSTER_7","REGION_POSTER_8",
			   "REGION_POSTER_9","REGION_POSTER_10","REGION_POSTER_11","REGION_POSTER_12",
			   "REGION_POSTER_13","REGION_POSTER_14"] and partyid=="UISPIELER"):
			dialogs.initDlg_022_WasIstDasFuerEinPlakat()
			data().Poster_gesehen = True

	# erstes Betreten Schrottplatz
	if id=="REGION_SCHROTT":
		if not data().erstes_betreten:
			dialogs.initDlg_041_NixAnfassen()
		if not data().player_knows_schrottplatz:
			data().player_knows_schrottplatz = True
			system.add_minimap_marker(235.30, 634.58,"MM_006")# Umbertos Schrottplatz

	# Leiche des Schattens im Lager gesehen
	if id=="REGION_SCHATTEN":
		dialogs.initDlg_020_VerwundertUeberLeiche()
		if hasattr(data('zone_5.zone_5'), 'Leiche_Kann_Weg'):
			data().Leiche_Kann_Weg = True

	# Ritual wird beobachtet
	if id=="REGION_RITUAL" and not data().Region_betreten:
		if not data().player_knows_station_im_wald:
			data().player_knows_station_im_wald = True
			system.add_minimap_marker(741.21, 652.55,"MM_004")# Station im Wald
			
		# Bei Angriff Trigger abfangen
		if data().sekte_wird_angegriffen:
			return
			
		data().Region_betreten = True
		if data().Kopfe == 5:
			data().Region_betreten = True
			objects.cancel_commandos("ALTER_EGO")
			#if system.get_qb_entry_state(data().QB_008) == COMPLETE:
			dialogs.initCutscene_028_Ritual_beginnt()
		else:
			enemy_script.delay(5, Lambda('data().Region_betreten = False'))
			enemy_script.delay(5, Lambda('system.notify_region_entered(region="REGION_RITUAL",partyid="UISPIELER")'))

	# Sekte greift an
	if id=="REGION_RITUAL_2" and not data().Region_Ritual_2:
		data().Region_Ritual_2 = True
		# Bei Angriff Trigger abfangen
		if data().sekte_wird_angegriffen:
			return
		if data().Kopfe == 5:
			if not objects.is_destroyed("SECT_PRIEST"):
				if not data().Olivia_Erstochen:
					data().sekte_wird_angegriffen = True
					objects.cancel_commandos("ALTER_EGO")
					dialogs.initDlg_030_PriesterFordertJuengerAufZuKaempfen()
					if data().Opferung_Active and dialog.is_dialog_active():
						data().Opferung_Active = False
						
						dialog.jump_to("ENDDIALOG","Opferung")

		else:
			data().Region_Ritual_2 = False
	
	if id == "WorldofDrugs":
		if not data().player_see_drugdisposal:
			data().player_see_drugdisposal = True
			dialogs.initDlg_069_SpielerErkenntDrogenAusgabeStelle()
		
		
		
# Opfer ist Tod
	if id=="REGION_OLIVIA_1" and not data().Region_Olivia_1:
		data().Region_Olivia_1 = True
		if data().Kopfe == 5:
			if data().Olivia_Erstochen:
				dialogs.initDlg_034_SpielerKonnteOpferNichtVerhindern()
		else:
			data().Region_Olivia_1 = False

def can_use( character_id, object_id ):
	if (object_id.rfind(QI_POSTER[1]) != -1):
		return True
	
	if (object_id==QI_TAGEBUCH[0]):
		return True
	
	if (object_id.rfind(QI_SOLARZELLE[1]) != -1):
		if objects.count_in_inventory(character_id,object_id):
			return True
		else:
			return False
	
	if (object_id.rfind("SET_SOLAR_CELLS") != -1):
		if objects.count_in_inventory(character_id,object_id):
			return True
		else:
			return False
	
	if (object_id.rfind(QI_BLASTER[1]) != -1):
		if object_id in objects.get_inventory_id_list(character_id):
			return True
		else:
			return False
	
	return object_events.can_use( character_id, object_id )
	
## benutzen von items / objekten
def on_use( character_id, object_id, item_id, item_type ):
	# Flugblaetter lesen
	if item_type == "SET_WANTED_POSTER":
		dialogs.initDlg_023_Steckbriefe()
		data().Poster_gelesen = True
		return True

	# Tagebuch von Tizoc lesen
	if (item_id==QI_TAGEBUCH[0]):
		dialogs.initDlg_076_Tagebuch()
		return True
	
	## Solarzelle und Ghettoblaster
	if item_type == "SET_SOLAR_CELLS":
		if objects.count_in_inventory(character_id,QI_BLASTER[1]):
			if objects.has_attribute(character_id,"technic"):
				if (objects.get_attribute(character_id,"technic") >= 60):
					objects.remove_item_from_inventory(character_id,QI_BLASTER[1])
					objects.remove_item_from_inventory(character_id,item_id)
					objects.create_item_in_inventory(character_id,QI_BLASTERFIXED[0],QI_BLASTERFIXED[1])
					objects.set_attribute(object=QI_BLASTERFIXED[1], attribute="generic_item", value=False)
					return True
		if objects.count_in_inventory(character_id,"SET_SOLAR_CELLS"):
			if objects.has_attribute(character_id,"technic"):
				if (objects.get_attribute(character_id,"technic") >= 60):
					objects.remove_item_from_inventory(character_id,"SET_SOLAR_CELLS")
					objects.remove_item_from_inventory(character_id,item_id)
					objects.create_item_in_inventory(character_id,QI_BLASTERFIXED[0],QI_BLASTERFIXED[1])
					objects.set_attribute(object=QI_BLASTERFIXED[1], attribute="generic_item", value=False)
					return True
					
	if item_type == "SET_BROKEN_DOWN_GHETTO_BLASTER":
		sc = hasSolarCell(character_id)
		#print "hasSolarCell() returned:",sc
		if sc != "None":
			if objects.has_attribute(character_id,"technic"):
				if (objects.get_attribute(character_id,"technic") >= 60):
					objects.remove_item_from_inventory(character_id,item_id)
					objects.remove_item_from_inventory(character_id,sc)
					objects.create_item_in_inventory(character_id,QI_BLASTERFIXED[0],QI_BLASTERFIXED[1])
					objects.set_attribute(object=QI_BLASTERFIXED[1], attribute="generic_item", value=False)
					return True
		
	return object_events.on_use( character_id, object_id, item_id, item_type )

def hasSolarCell(char_id):
	sc = QI_SOLARZELLE[1]
	solarcells = [sc+"_1", sc+"_2",sc+"_3","SET_SOLAR_CELLS"]
	for solarcell in solarcells:
		if objects.count_in_inventory(char_id, solarcell):
			return solarcell
	return "None"

# Boese machen
def initFoeLists():
	for id in NPC_RATSKULLS:
		objects.set_attribute( id, attribute="foes",value=["UISPIELER"])

	for dm in NPC_RATSKULL_DRUG_MULES:
		objects.set_attribute( dm,"foes",value=["UISPIELER"])

	# Warge
	objects.set_attribute( "WARG_1", attribute="foes", value= ["UISPIELER"])
	objects.set_attribute( "WARG_2", attribute="foes", value= ["UISPIELER"])
	objects.set_attribute( "WARG_3", attribute="foes", value= ["UISPIELER"])
	objects.set_attribute( "WARG_4", attribute="foes", value= ["UISPIELER"])
	objects.set_attribute( "WARG_5", attribute="foes", value= ["UISPIELER"])
	
	#objects.set_attribute("DAN","foes",PCs)
	objects.set_attribute("PHOENIX","foes",["UISPIELER"])
	
def can_exchange( character_id, target_id, item_id, item_type ):
	#if character_id == "ALTER_EGO":
	if target_id == "ZACHARY":
		if item_id == QI_BLASTERFIXED[1] or item_type  == "SET_REPAIRED_GHETTOBLASTER":
			return True
		elif item_id == QI_BLASTER[1] or item_type  == "SET_BROKEN_DOWN_GHETTO_BLASTER":
			if enemy_script.count_party_inventory(area = 15, object_id = "ZACHARY", items = "SET_SOLAR_CELLS"):
				return True
			else:
				erg = enemy_script.count_party_inventory(area = 15, object_id = "ZACHARY", items = [QI_SOLARZELLE[1]+'_1',QI_SOLARZELLE[1]+'_2',QI_SOLARZELLE[1]+'_3'])
				for id in [QI_SOLARZELLE[1]+'_1',QI_SOLARZELLE[1]+'_2',QI_SOLARZELLE[1]+'_3']:
					if erg[id]:
						return True
		elif item_id in [QI_SOLARZELLE[1]+'_1',QI_SOLARZELLE[1]+'_2',QI_SOLARZELLE[1]+'_3']:
			if enemy_script.count_party_inventory(area = 15, object_id = "ZACHARY", items = QI_BLASTER[1]):
				return True
		elif item_type  == "SET_SOLAR_CELLS":
			if enemy_script.count_party_inventory(area = 15, object_id = "ZACHARY", items = QI_BLASTER[1]):
				return True
			else:
				return False
	
	if target_id == "GENERAL_LEWIS":
			if item_id in ["SET_WATER_DETECTOR","SET_TENT_CANVAS"]:
				return True

	if target_id == "NICHOLAS":
			if (item_id.rfind(QI_WARGHEAD[1]) != -1):
				return True

	return object_events.can_exchange( character_id, target_id, item_id, item_type )

def on_exchange( character_id, target_id, item_id, item_type ):
	#print "[debug",character_id, target_id, item_id, item_type,"]"
	# Schaedel zum Buergermeister
	if (target_id=="NICHOLAS" and (item_id.rfind(QI_WARGHEAD[1]) != -1)):
		data().Kopfe += 1
		if not data().Kopfe == 5:
			character.add_experience_party(70)
		else:
			character.add_experience_party(100)
		if not system.get_qb_entry_state(data().QB_008) in [COMPLETE, UNCOMPLETE]:
			system.set_qb_entry_state(data().QB_008, UNCOMPLETE)
		if system.get_qb_entry_state(data().QB_017) != INACTIVE:
			system.set_qb_entry_state(data().QB_017, INACTIVE)
		if data().Kopfgeld_fuer_Schaedel==0:
			dialogs.initDlg_026_SpielerHoltKopfgeld_1()
		elif data().Kopfgeld_fuer_Schaedel==1:
			dialogs.initDlg_047_SpielerHoltKopfgeld_2()
		elif data().Kopfgeld_fuer_Schaedel==2:
			dialogs.initDlg_029_SpielerHoltKopfgeld_3()
		elif data().Kopfgeld_fuer_Schaedel==3:
			dialogs.initDlg_049_SpielerHoltKopfgeld_4()
		elif data().Kopfgeld_fuer_Schaedel==4:
			dialogs.initDlg_048_SpielerHoltKopfgeld_5()
		return True

	# Ghettoblaster austausch
	if (target_id=="ZACHARY" and (system.get_qb_entry_state(data().QB_006) == UNCOMPLETE)):
		if (item_type=="SET_REPAIRED_GHETTOBLASTER") or (item_id.rfind(QI_BLASTERFIXED[1]) != -1):
			dialogs.initCutscene_038_SpielerGibtZacharyBlasterZurueck()
			return True
		
		if item_type == "SET_SOLAR_CELLS" and item_id in [QI_SOLARZELLE[1]+'_1',QI_SOLARZELLE[1]+'_2',QI_SOLARZELLE[1]+'_3']:
			data().Zellen = True
		elif item_type == "SET_SOLAR_CELLS":
			data().Zellen = True
		
		if data().Zellen and not data().Blaster:
			if enemy_script.count_party_inventory(area = 15, object_id = "ZACHARY", items = QI_BLASTER[1]):
				objects.transfer_item(enemy_script.get_next_transfer_partner("ZACHARY",QI_BLASTER[1]),QI_BLASTER[1],"ZACHARY")
				data().Blaster = True
			elif enemy_script.count_party_inventory(area = 15, object_id = "ZACHARY", items = QI_BLASTERFIXED[1]):
				objects.transfer_item(enemy_script.get_next_transfer_partner("ZACHARY",QI_BLASTERFIXED[1]),QI_BLASTERFIXED[1],"ZACHARY")
				dialogs.initCutscene_038_SpielerGibtZacharyBlasterZurueck()
				return True
		
		if item_type == "SET_BROKEN_DOWN_GHETTO_BLASTER":
			#objects.transfer_item(character_id, "SET_BROKEN_DOWN_GHETTO_BLASTER", "ZACHARY")
			data().Blaster = True
			if enemy_script.count_party_inventory(area = 15, object_id = "ZACHARY", items = "SET_SOLAR_CELLS"):
				objects.transfer_item(enemy_script.get_next_transfer_partner("ZACHARY","SET_SOLAR_CELLS"),"SET_SOLAR_CELLS","ZACHARY")
				data().Zellen = True
			else:
				erg = enemy_script.count_party_inventory(area = 15, object_id = "ZACHARY", items = [QI_SOLARZELLE[1]+'_1',QI_SOLARZELLE[1]+'_2',QI_SOLARZELLE[1]+'_3'])
				for id in [QI_SOLARZELLE[1]+'_1',QI_SOLARZELLE[1]+'_2',QI_SOLARZELLE[1]+'_3']:
					if erg[id] and not data().Zellen:
						objects.transfer_item(enemy_script.get_next_transfer_partner("ZACHARY",id),id,"ZACHARY")
						data().Zellen = True
		
		if (data().Blaster and data().Zellen):
			dialogs.initDlg_059_Zellen_Blaster()
			return True
	
	# Zelte und Detektoren
	if (target_id=="GENERAL_LEWIS"):
		if (item_type=="SET_WATER_DETECTOR" and system.get_qb_entry_state(data().QB_002) == UNCOMPLETE):
			if data().Detector < 5:
				data().Detector += 1
				genug_wasser_detectoren()
				return True

		if (item_type=="SET_TENT_CANVAS" and system.get_qb_entry_state(data().QB_002) == UNCOMPLETE):
			if data().Tent < 5:
				data().Tent += 1
				genug_wasser_detectoren()
				return True

	return object_events.on_exchange( character_id, target_id, item_id, item_type )

def genug_wasser_detectoren():
	if (data().Detector == 4 and data().Tent == 4):
		system.set_qb_entry_state(data().QB_002,COMPLETE)
		
def initFX():
	# Lagerfeuer
	for id in OBJ_LAGERFEUER:
		system.start_effect_object(object=id,node="effekt_feuer",parameter=fx_fire_lagerfeuer)
		system.start_effect_object(object=id,node="effekt_feuer",parameter=fx_smoke_lagerfeuer)
		system.start_effect_object(object=id,node="effekt_feuer01",parameter=fx_fire_lagerfeuer_01)
		system.start_effect_object(object=id,node="effekt_feuer02",parameter=fx_fire_lagerfeuer_02)
		system.start_effect_object(object=id,node="effekt_feuer03",parameter=fx_fire_lagerfeuer_03)
		system.start_effect_object(object=id,node="effekt_feuer04",parameter=fx_fire_lagerfeuer_04)
		sounds.play_3d_sound_object(sfx_id="campfire_big",object=id,loop=True)

	# Brennendes Haus
	if not data().phoenix_kill:
		system.start_effect_object(object="BUILDING_3123",node="rauch01",parameter=[FX_FIRE_SHAPE,0,20*60*1000,0.4,0,0])
		for i in range(10):
			system.start_effect_object(object="BUILDING_3123",
				node="rauch%.2d" % (i+1),
				#parameter=[FX_VEHICLE_SMOKE,0,20*60*1000+random.randint(10*1000,30*1000),10.0+(random.random()*2),10.0,0.2,0x3D3732,0.8])
				parameter = fx_smoke )
		sounds.play_3d_sound_object(sfx_id="smooth_firecracks",object="BUILDING_3123",loop=True)
	
	#brennende tonnen
	#for id in []:
	#	fxBrennendeTonne(id)

def fxBrennendeTonne(_objectid):
	#system.start_effect_object(object=_objectid,node="sort0",parameter=fx_smoke_brennende_tonne)
	system.start_effect_object(object=_objectid,node="sort1",parameter=fx_fire_brennende_tonne)
	sounds.play_3d_sound_object(sfx_id="campfire_small",object=_objectid,loop=True)

def ratskullalarm(victim, groupmember, attacker):
	for ratskull in groupmember:
		if objects.get_distance_to_object(victim,ratskull) < 20:
			if not objects.is_destroyed(ratskull):
				if not objects.is_fighting(ratskull):
					prohibit_activity(ratskull, False)
					if not attacker == None:
						objects.attack(ratskull, attacker)
					else:
						objects.attack(ratskull, 'ALTER_EGO')

## callback: was an object killed?
def on_object_killed(victim, attacker, weapon_type, weapon_id, victims_party):
	object_events.on_object_killed(victim, attacker, weapon_type, weapon_id, victims_party)
	
	if victim in data().warg_positionen.keys():
		if not data().warg_spotted:
			data().warg_spotted = True
			dialogs.initDlg_083_SpielerStauntUeberWarge()

	if victim in NPC_RATSKULLS_WASSER:
		if not data().ratskulls_lager_alarmed:
			data().ratskulls_lager_alarmed = True
			for ratskull in RATSKULLS_V1 + RATSKULLS_V2 + RATSKULLS_V3:
				if not objects.is_destroyed(ratskull):
					prohibit_activity(ratskull, False)
					objects.move_to_object(ratskull, victim, speed=MT_FAST)
					data().ratskull_base_alarmed = True

	# aendern der Patrolien bei Alarm
	if victim in ["RATSKULL_TP_1","RATSKULL_TP_2"]:
		if not data().TorpostenTod:
			if victim == "RATSKULL_TP_1":
				survivor = "RATSKULL_TP_2"
			else:
				survivor = "RATSKULL_TP_1"
			if not objects.is_destroyed(survivor):
				objects.move_to(survivor,623,394, "landscape",MT_FAST, callback= ["ONEND",Lambda('objects.turn_to_position("%s",618.04,396.14)'%survivor)])
				#objects.turn_to_object(survivor,victim)
				character.change_body_mode(survivor,"KNEEL")
	
			if not objects.is_destroyed("RATSKULL_R_2"):
				objects.move_to("RATSKULL_R_2",617,386, "landscape",MT_FAST)
			if not objects.is_destroyed("RATSKULL_R_3"):
				objects.move_to("RATSKULL_R_3",615,389, "landscape",MT_FAST)
			if not objects.is_destroyed("RATSKULL_R_8"):
				objects.move_to("RATSKULL_R_8",625,395, "landscape",MT_FAST)
			if not objects.is_destroyed("RATSKULL_R_9"):
				objects.move_to("RATSKULL_R_9",615,391, "landscape",MT_FAST)
			if not objects.is_destroyed('RATSKULL_TW_1'):
				objects.move_to("RATSKULL_TW_1",626,391, "landscape",MT_FAST)
			for ID in ["RATSKULL_R_2","RATSKULL_R_3","RATSKULL_R_8","RATSKULL_R_9","RATSKULL_TW_1"]:
				if not objects.is_destroyed(ID):
					character.arm_direct(ID)
					character.change_body_mode(ID,"KNEEL", callback= ["ONEND",Lambda('objects.turn_to_position("%s",618.04,396.14)'%ID)])
			data().TorpostenTod = True
			data().ratskull_base_alarmed = True

	if victim=="RATSKULL_WT_1":
		if not objects.is_destroyed('RATSKULL_WT_2'):
			objects.move_to("RATSKULL_WT_2",620,310, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_WT_2",135)
		if not objects.is_destroyed('RATSKULL_WT_3'):
			objects.move_to("RATSKULL_WT_3",614,309, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_WT_3",225)
		if not objects.is_destroyed('RATSKULL_TP_3'):
			objects.move_to("RATSKULL_TP_3",617,310, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_TP_3",180)
		if not objects.is_destroyed('RATSKULL_R_6'):
			objects.move_to("RATSKULL_R_6",562,360, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_R_6",270)
		if not objects.is_destroyed('RATSKULL_R_7'):
			objects.move_to("RATSKULL_R_7",563,353, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_R_7",270)

	if victim=="RATSKULL_WT_2":
		if not objects.is_destroyed('RATSKULL_WT_1'):
			objects.move_to("RATSKULL_WT_1",620,310, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_WT_1",135)
		if not objects.is_destroyed('RATSKULL_WT_3'):
			objects.move_to("RATSKULL_WT_3",614,309, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_WT_3",225)
		if not objects.is_destroyed('RATSKULL_TP_3'):
			objects.move_to("RATSKULL_TP_3",617,310, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_TP_3",180)
		if not objects.is_destroyed('RATSKULL_R_6'):
			objects.move_to("RATSKULL_R_6",562,360, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_R_6",270)
		if not objects.is_destroyed('RATSKULL_R_7'):
			objects.move_to("RATSKULL_R_7",563,353, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_R_7",270)

	if victim=="RATSKULL_WT_3":
		if not objects.is_destroyed('RATSKULL_WT_2'):
			objects.move_to("RATSKULL_WT_2",620,310, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_WT_2",135)
		if not objects.is_destroyed('RATSKULL_WT_1'):
			objects.move_to("RATSKULL_WT_1",614,309, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_WT_1",225)
		if not objects.is_destroyed('RATSKULL_TP_3'):
			objects.move_to("RATSKULL_TP_3",617,310, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_TP_3",180)
		if not objects.is_destroyed('RATSKULL_R_6'):
			objects.move_to("RATSKULL_R_6",562,360, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_R_6",270)
		if not objects.is_destroyed('RATSKULL_R_7'):
			objects.move_to("RATSKULL_R_7",563,353, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_R_7",270)

	if victim in data().Ratskulls_v_4:
		data().Ratskulls_v_4.remove(victim)
		for ratskull in data().Ratskulls_v_1 + data().Ratskulls_v_2 + data().Ratskulls_v_3:
			if not objects.is_destroyed(ratskull):
				data().Ratskulls_v_4.append(ratskull)
				prohibit_activity(ratskull, False)
				objects.move_to_object(ratskull, victim, speed=MT_FAST)
		ratskullalarm(victim, data().Ratskulls_v_4, attacker)
		data().Ratskulls_v_1 = []
		data().Ratskulls_v_2 = []
		data().Ratskulls_v_3 = []

	if victim in data().Ratskulls_v_1:
		data().Ratskulls_v_1.remove(victim)
		if len(data().Ratskulls_v_2):
			ratskull = data().Ratskulls_v_2.pop(0)
			if not objects.is_destroyed(ratskull):
				data().Ratskulls_v_1.append(ratskull)
				prohibit_activity(ratskull, False)
				objects.move_to_object(ratskull, victim, speed=MT_FAST)
		ratskullalarm(victim, data().Ratskulls_v_1, attacker)

	if victim in data().Ratskulls_v_2:
		data().Ratskulls_v_2.remove(victim)
		if len(data().Ratskulls_v_1):
			ratskull = data().Ratskulls_v_1.pop(0)
			if not objects.is_destroyed(ratskull):
				data().Ratskulls_v_2.append(ratskull)
				prohibit_activity(ratskull, False)
				objects.move_to_object(ratskull, victim, speed=MT_FAST)
		ratskullalarm(victim, data().Ratskulls_v_2, attacker)

	if victim in data().Ratskulls_v_3:
		data().Ratskulls_v_3.remove(victim)
		for ratskull in data().Ratskulls_v_2:
			data().Ratskulls_v_3.append(ratskull)
			if not objects.is_destroyed(ratskull):
				prohibit_activity(ratskull, False)
				objects.move_to_object(ratskull, victim, speed=MT_FAST)
		ratskullalarm(victim, data().Ratskulls_v_3, attacker)
		data().Ratskulls_v_2 = []

	# Zaehler fuer rats im Lager
	if victim in NPC_RATSKULLS_WASSER:
		data().kill_wasser+=1

	# Zaehler fuer Vorposten rats
	if victim in NPC_RATSKULLS_VORPOSTEN:
		data().kill_vorposten+=1

	# alle im Lager und min. 75% Vorposten Tod
	if (data().kill_wasser == 20 and data().ratstod == 0): # and data().kill_vorposten >= 9
		data().ratstod += 1
		objects.set_active_state("PATRICK", INACTIVE)
		if not objects.is_destroyed("DAN") and objects.is_active("DAN") and objects.get_attribute("DAN","approachable"):
			dan_finish_drugwork()
			for p in ROUTE_PHOENIX:
				if not p == ROUTE_PHOENIX[len(ROUTE_PHOENIX)-1]:
					objects.move_to("DAN",p[0],p[1],"landscape",MT_FAST)
				else:
					objects.move_to("DAN",p[0],p[1],"landscape",MT_FAST, callback=["ONEND",deactivate])
			system.notify_timer(data().Timer_DanAufhalten,data().Timervalue_DanAufhalten)

	# Die Gang ist Tod
	if victim in NPC_ROWDIES:
		data().rowdies_killed+=1

	if data().rowdies_killed==4:
		pass
		if system.get_qb_entry_state(data().QB_004)==UNCOMPLETE:
			system.set_qb_entry_state(data().QB_004,INACTIVE)
			system.set_qb_entry_state(data().QB_001,UNCOMPLETE)

	# Phoenix ist tot
	if victim == "PHOENIX" and data().phoenix_kill:
		dialogs.onDlg_082_PhoenixFertig()
		character.add_experience_party(data().Exp_Kampf_gegen_Ratskulls)
			
	# Mustafa fand die Regierung nich so gut
	if victim=="MUSTAFA":
		data().Mustafa_Tod = True
		dialogs.initDlg_010_Mustafa_ist_killed()

	# Die Sekte brauch einen neuen Chef
	if victim=="TIZOC":
		if system.get_qb_entry_state(data().QB_010) in [UNCOMPLETE]:
			system.set_qb_entry_state(data().QB_010,COMPLETE)
			character.add_experience_party(data().Exp_Tizoc_getoetet)
		system.create_object(equipmenttype=QI_TAGEBUCH[0],x=678,y=499,direction=0, id=QI_TAGEBUCH[1])
		objects.set_attribute(object=QI_TAGEBUCH[1], attribute="generic_item", value=False)
		

	# Die Sekte ist erledigt
	if victim in NPC_SEKTE:
		data().Sektenmitglieder1+=1
		
		if data().Sektenmitglieder1 == len(NPC_SEKTE)-1:
			last = None
			for id in NPC_SEKTE:
				if not objects.is_destroyed(id):
					if id != "SECT_PRIEST":
						last = id
					else:
						last = id
						objects.set_attribute(last, "name", globaltext.NAME_SECTARIAN)
						objects.set_attribute(last, "resourceui", "sectarian.png")

			data().last_sectarian = last
			Letztes_Mitglied(last)

		if data().Sektenmitglieder1 == len(NPC_SEKTE):
			data().Sekte_Ausgerottet = True # bis auf den letzten der lebt noch
		
	# Letztes Sektenmitglied ist tod
	if data().last_sectarian != None:
		if victim==data().last_sectarian:
			data().Sekte_Ausgerottet1 = True
			#prohibit_activity("TIZOC",False)
			#objects.move_to("TIZOC",678,500)
			if ((system.get_qb_entry_state(data().QB_005) in [UNCOMPLETE,COMPLETE]) or (system.get_qb_entry_state(data().QB_008) in [UNCOMPLETE,COMPLETE])):
				dialogs.initDlg_044_Sekte_komplett()
			else:
				dialogs.initDlg_077_SpielerKilltSekteOhneWargInfo()

#alarm in der basis
def rs_base_alert(victim):
	if not data().ratskull_base_alarmed:
		data().ratskull_base_alarmed = True
		for id in NPC_RATSKULLS:
			if objects.is_destroyed(id):
				return False
			if not objects.has_attribute(id, "foes"):
				objects.cancel_commandos(id)
				if id in schedules.schedules.keys():
					prohibit_activity(id)
				objects.set_attribute(id, "foes", ['UISPIELER'])
			objects.turn_to_object(id, victim)
			if objects.get_distance(id, victim) < 40.0:
				x,y,z = objects.get_position(victim)
				objects.move_to(id, x,y, speed=MT_FAST, grid="landscape")
				pass
	return None

def dan_finish_drugwork():
	objects.cancel_commandos("DAN")
	prohibit_activity("DAN")
	objects.cancel_commandos("DAN")
	character.set_approachable_state("DAN", NOTAPPROACHABLE)
	#objects.step_away("DAN")
	objects.step_to("DAN", 630.2, 377.1, speed = MT_FAST)
	objects.move_to("DAN", 629.99, 374.87, grid="ZONE_5_BUILDING_10565_INTERIOR_GRID1", speed = MT_FAST)
	objects.move_to("DAN", 627.91, 378.01, grid="ZONE_5_BUILDING_10565_INTERIOR_GRID1", speed = MT_FAST)

## helper: deactivate an object
def deactivate(id):
	if id == "PATRICK":
		data().seeker_aufgehalten = True
	objects.set_active_state(id,INACTIVE)

# Verfolgen von letztem Mitglied
def Letztes_Mitglied(sectarian):
	objects.set_immortal_state(sectarian, True)
	if not objects.is_destroyed(sectarian):
		objects.set_attribute(data().last_sectarian, "foes", None)
		objects.cancel_commandos(data().last_sectarian)
		if character.is_equiped(data().last_sectarian, "SET_SPECIAL_38"):
			character.un_equip_direct(data().last_sectarian, "SET_SPECIAL_38")
		if not objects.is_destroyed(sectarian):
			objects.step_away(sectarian)
		found = False
		for id in system.get_pcs():
			if found:
				return
			if objects.get_distance(id, sectarian) < 3:
				found = True
				objects.cancel_commandos(sectarian)
				character.change_body_mode(sectarian, "KNEEL")
				init_cutscene("ALTER_EGO", sectarian)
				objects.turn_to_object("ALTER_EGO",sectarian)
				if not objects.is_destroyed(sectarian):
					objects.turn_to_object(sectarian,"ALTER_EGO")
		if not found:
			if not data().Big_Run1:
				system.notify_timer(data().Timer_Sekte_6,data().Timervalue_Sekte_6)
				if not objects.is_destroyed(sectarian):
					objects.move_to(sectarian, 733.83, 667.61, "landscape",MT_FAST,["ONEND",Big_Run]) # 734,632

def Big_Run(sectarian):
	if not objects.is_destroyed(sectarian):
		objects.turn_to_object(sectarian, 'OLIVIA')
	data().Big_Run1 = True

# Sekte verlaeßt Zone nach Opfer
def Sekte_Verschwindet(id):
	objects.move_to("SECT_PRIEST", 723,638, "landscape",MT_SLOW,["ONEND",Abgang])
	for id in ["SEKTE_1","SEKTE_2","SEKTE_3","SEKTE_4","SEKTE_5","SECTARIAN"]:
		if not objects.is_destroyed(id):
			objects.move_to(id, 723,639, "landscape",MT_SLOW)

def Abgang(id):
	objects.step_away("SECT_PRIEST")
	if data().sekte_wird_angegriffen:
		objects.move_to("SECT_PRIEST", 915.5,639.5, "landscape",MT_SLOW)
	else:
		objects.move_to("SECT_PRIEST", 915.5,639.5, "landscape",MT_SLOW,callback=["ONEND",Deaktivieren])
	for id in ["SEKTE_1","SEKTE_2","SEKTE_3","SEKTE_4","SEKTE_5","SECTARIAN"]:
		if not objects.is_destroyed(id):
			objects.move_to(id, 915.4,639.6, "landscape",MT_SLOW)

def Deaktivieren(id):
	objects.set_active_state("SECT_PRIEST",INACTIVE)
	for id in ["SEKTE_1","SEKTE_2","SEKTE_3","SEKTE_4","SEKTE_5","SECTARIAN"]:
		if not objects.is_destroyed(id):
			objects.set_active_state(id,INACTIVE)

def on_sector_cleared(object_id):
	#print "[on_sector_cleared(",object_id,")]"
	return
	"""if objects.is_npc(object_id):
		if object_id == "SECT_PRIEST":
			if data().Sektenmitglieder1 == 6:
				if not objects.is_destroyed("SECT_PRIEST"):
					objects.cancel_commandos("SECT_PRIEST")
					dialogs.initCutscene_075_PriesterToetetOliviaDochNoch()"""

## callback: was an enemy spotted?
def on_enemy_spotted(object_id):
	#print "[on_enemy_spotted(",object_id,")]"
	if object_id == "Z5 PICKUP":
		return True
	
	enemys = character.get_visible_enemies(object_id)
	if objects.is_npc(object_id) and len(enemys):
		
		if object_id in ["RATSKULL_HUMMER_3","RATSKULL_HUMMER_4"]:
			if not hasattr(data(), "ratskulls_hummer_attacked"):
				data().ratskulls_hummer_attacked = True
				for id in ["RATSKULL_HUMMER_3","RATSKULL_HUMMER_4"]:
					if not objects.is_destroyed(id):
						if not objects.is_fighting(id):
							objects.attack(id, random.choice(enemys))

		if object_id in NPC_RATSKULL_DRUG_MULES:
			prohibit_activity(object_id, False)
			if not objects.is_fighting(object_id):
				objects.attack(object_id, random.choice(enemys))
		
		elif object_id in ["RATSKULL_HUMMER_1","RATSKULL_HUMMER_2"]:
			for id in ["RATSKULL_HUMMER_1","RATSKULL_HUMMER_2"]:
				if not objects.is_destroyed(id):
					if not objects.is_fighting(id):
						prohibit_activity(object_id, False)
						objects.attack(id,random.choice(enemys))
		else:
			if not objects.is_destroyed(object_id):
				if not objects.is_fighting(object_id):
					prohibit_activity(object_id, False)
					objects.attack(object_id,random.choice(enemys))
	return None

## callback: was an enemy attacked?
def on_attack(operator, target):
	#print"target:",target
	if target in ["RATSKULL_HUMMER_3","RATSKULL_HUMMER_4"]:
		if not hasattr(data(), "ratskulls_hummer_attacked"):
			data().ratskulls_hummer_attacked = True
			for id in ["RATSKULL_HUMMER_3","RATSKULL_HUMMER_4"]:
				if not objects.is_destroyed(id):
					if not objects.is_fighting(id):
						objects.attack(id, operator)
	
	if target in NPC_SEKTE:
		#if objects.is_destroyed("OLIVIA"):
		if not data().sekte_wird_angegriffen:
			data().sekte_wird_angegriffen = True
			for sekt in NPC_SEKTE:
				if sekt != target:
					if not objects.is_destroyed(sekt):
						objects.cancel_commandos(sekt)
						if target == "SECT_PRIEST":
							objects.step_away("SECT_PRIEST")
						objects.turn_to_object(sekt,target)
						objects.set_attribute(sekt,"foes",["UISPIELER"])
						if not character.is_equiped(sekt, "SET_SPECIAL_38"):
							character.equip(sekt,"SET_SPECIAL_38")
						enemies = character.get_visible_enemies(operator)
						if len(enemies):
							enemy = random.choice(enemies)
							if not objects.is_destroyed(enemy):
								objects.attack(sekt, enemy)
			#Angriffdialog der Sekte ausloesen
			dialogs.initDlg_030_PriesterFordertJuengerAufZuKaempfen()
			
			# Dialog bei Opferung abbrechen
			if data().Opferung_Active and dialog.is_dialog_active():
				data().Opferung_Active = False
				
				dialog.jump_to("ENDDIALOG","Opferung")
							
	if target in NPC_ROWDIES:
		if not data().rowdies_bewaffnet:
			if not objects.is_destroyed("BRANDON"):
				prohibit_activity("BRANDON")
				character.equip_direct( "BRANDON", equipment="SET_COLT_45", direct_ammo_load=True)
			if not objects.is_destroyed("SCHLAEGER_1"):
				character.equip_direct( "SCHLAEGER_1", equipment="SET_SPECIAL_38", direct_ammo_load=True)
			if not objects.is_destroyed("SCHLAEGER_2"):
				character.equip_direct( "SCHLAEGER_2", equipment="SET_SPECIAL_38", direct_ammo_load=True)
			if not objects.is_destroyed("SCHLAEGER_3"):
				character.equip_direct( "SCHLAEGER_3", equipment="SET_COLT_45", direct_ammo_load=True)
			data().rowdies_bewaffnet = True
			for id in NPC_ROWDIES:
				if not objects.is_destroyed(id):
					if not objects.is_fighting(id):
						objects.set_attribute(id,"foes",["UISPIELER"])
	
	if target in NPC_MUSTAFA:
		if not data().mustafas_bewaffnet:
			if not data().aysha_geflohen:
				data().aysha_geflohen = True
				prohibit_activity("AYSHA")
				import npc_activities
				func = npc_activities.enter_building("BUILDING_415")
				func("AYSHA")
			if not objects.is_destroyed("MUSTAFA"):
				character.equip_direct( "MUSTAFA", equipment="SET_COLT_45", direct_ammo_load=True )
			if not objects.is_destroyed("MEHMET"):
				prohibit_activity("MEHMET")
				character.equip_direct( "MEHMET", equipment="SET_SPECIAL_38", direct_ammo_load=True )
			if not objects.is_destroyed("ALI"):
				prohibit_activity("ALI")
				character.equip_direct( "ALI", equipment="SET_SPECIAL_38", direct_ammo_load=True )
			data().mustafas_bewaffnet = True
			for id in NPC_MUSTAFA:
				if not objects.is_destroyed(id):
					if not objects.is_fighting(id):
						objects.set_attribute(id,"foes",["UISPIELER"])
			
	if target=="PHOENIX":
		if not data().phoenix_angeschossen:
			data().phoenix_angeschossen = True
			objects.set_attribute("PHOENIX","foes",None)
			objects.cancel_commandos("PHOENIX")
			allow_activity("PHOENIX")
			character.set_approachable_state("PHOENIX",APPROACHABLE)
			for id in system.get_pcs():
				objects.cancel_commandos(id)
			objects.set_immortal_state("PHOENIX",True)
			if character.is_equiped("PHOENIX", "SET_DESERT_EAGLE"):
				character.un_equip_direct("PHOENIX","SET_DESERT_EAGLE")
			objects.drop_item("PHOENIX","SET_DESERT_EAGLE")
			
			if data().ratstod == 0:
				dialogs.initCutscene_071_SpielerHatPhoenixAngeschossen()
			else:
				if not data().phoenix_gesprochen:
					system.set_qb_entry_state(data().QB_012, INACTIVE)
					if was_zone_entered("zone_4.zone_4"):
						system.set_qb_entry_state(data("zone_4.zone_4").QB_021, COMPLETE)
					dialogs.initCutscene_063_PhoenixGibtSichGeschlagen()
					
		# Versuch Stop Feuern auf Phönix
		"""
		elif not data().phoenix_gesprochen:
			print "cease fire", operator
			objects.cancel_commandos(operator)
			enemy_script.delay(2,Lambda('objects.cancel_commandos("%s")'%operator))
			
			visible_enemies = character.get_visible_enemies(operator)
			print "Enemies:", visible_enemies
			if visible_enemies:
				enemy = ""
				while enemy == "":
					enemy = random.choice(visible_enemies)
					if objects.is_destroyed(enemy):
						visible_enemies.remove(enemy)
						enemy = ""
						if not visible_enemies:
							break
						print "schleife",visible_enemies
				if enemy:
					objects.attack(operator,enemy)
			"""
	
	if target in RATSKULLS and not data().Alarm:
		data().Alarm = True
		if not objects.is_destroyed("RATSKULL_V1_1"):
			objects.move_to("RATSKULL_V1_1",605,412, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_V1_1",180)
		if not objects.is_destroyed("RATSKULL_V1_2"):
			objects.move_to("RATSKULL_V1_2",605,420, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_V1_2",180)
		if not objects.is_destroyed("RATSKULL_V1_3"):
			objects.move_to("RATSKULL_V1_3",606,426, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_V1_3",180)
		if not objects.is_destroyed("RATSKULL_V1_4"):
			objects.move_to("RATSKULL_V1_4",616,433, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_V1_4",180)
		if not objects.is_destroyed("RATSKULL_V2_1"):
			objects.move_to("RATSKULL_V2_1",621,427, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_V2_1",180)
		if not objects.is_destroyed("RATSKULL_V2_2"):
			objects.move_to("RATSKULL_V2_2",625,416, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_V2_2",180)
		if not objects.is_destroyed("RATSKULL_V3_1"):
			objects.move_to("RATSKULL_V3_1",614,478, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_V3_1",80)
		if not objects.is_destroyed("RATSKULL_V3_2"):
			objects.move_to("RATSKULL_V3_2",600,478, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_V3_2",270)
		if not objects.is_destroyed("RATSKULL_V3_3"):
			objects.move_to("RATSKULL_V3_3",591,466, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_V3_3",200)
		if not objects.is_destroyed("RATSKULL_V3_4"):
			objects.move_to("RATSKULL_V3_4",588,451, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_V3_4",270)
		if not objects.is_destroyed("RATSKULL_R_1"):
			objects.move_to("RATSKULL_R_1",563,322, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_R_1",270)
		if not objects.is_destroyed("RATSKULL_R_2"):
			objects.move_to("RATSKULL_R_2",600,389, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_R_2",90)
		if not objects.is_destroyed("RATSKULL_R_3"):
			objects.move_to("RATSKULL_R_3",596,381, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_R_3",100)
		if not objects.is_destroyed("RATSKULL_R_4"):
			objects.move_to("RATSKULL_R_4",565,364, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_R_4",170)
		if not objects.is_destroyed("RATSKULL_R_5"):
			objects.move_to("RATSKULL_R_5",564,348, "landscape",MT_FAST)
		if not objects.is_destroyed("RATSKULL_R_6"):
			objects.move_to("RATSKULL_R_6",505,328, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_R_6",90)
		if not objects.is_destroyed("RATSKULL_R_7"):	
			objects.move_to("RATSKULL_R_7",504,297, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_R_7",90)
		if not objects.is_destroyed("RATSKULL_R_8"):	
			objects.move_to("RATSKULL_R_8",620,389, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_R_8",90)
		if not objects.is_destroyed("RATSKULL_R_9"):	
			objects.move_to("RATSKULL_R_9",616,388, "landscape",MT_FAST)
			objects.turn_to_direction("RATSKULL_R_9",180)

## callback: has a timer been called?
def on_timer(id):
	#warten bis ratskulls im hummer sind
	if id == data().Timer_GetInHummerWait:
		dialogs.ratskulls_start_hummer()
		
	#warg versammlung
	if id == data().Timer_Wargversammlung:
		clock = system.get_mission_time().get_day_time()
		if clock >= time("00:45:00") and clock < time("02:00:00"):
			if not data().wargversammlung:
				data().wargversammlung = True
				for warg in data().warg_positionen.keys():
					if not objects.is_destroyed(warg):
						if data().warg_positionen[warg][0] == 0:
							data().warg_positionen[warg] = objects.get_position(warg)
						objects.cancel_commandos(warg)
						objects.move_to(warg,data().warg_meetingpoints[warg][0],data().warg_meetingpoints[warg][1], speed=MT_FAST, grid="landscape")
						objects.turn_to_direction(warg, data().warg_meetingpoints[warg][2])
				if not objects.exists("oh_my_deer"):
					system.create_animal(id="oh_my_deer",type=ANIMAL_DEER, party="ANIMALS", x=749.3, y=669.3, direction=150)
					objects.destroy("oh_my_deer")
				
		if clock < time("00:45:00") or clock >= time("02:00:00"):
			if data().wargversammlung:
				data().wargversammlung = False
				for warg in data().warg_positionen.keys():
					if not objects.is_destroyed(warg):
						objects.cancel_commandos(warg)
						objects.move_to(warg,data().warg_positionen[warg][0],data().warg_positionen[warg][1], speed=MT_FAST, grid="landscape")
		
		system.notify_timer(data().Timer_Wargversammlung,data().Timervalue_Wargversammlung)
		
	#print "[debug on_timer()",id,"]"
	if id == data().Timer_OliviaSound:
		if not data().Olivia_frei:
			if objects.is_active('OLIVIA'):
				sounds.play_3d_sound_object(sfx_id="weeping_female",object="OLIVIA")
			system.notify_timer(data().Timer_OliviaSound, 9500)
	
	## drogenkuriere stoppen
	if id==data().Timer_RatskullDrogenkuriereAufhalten:
		kill_count = 0
		for dm in NPC_RATSKULL_DRUG_MULES:
			if objects.is_destroyed(dm):
				kill_count += 1
			else:
				if objects.is_destroyed("ALTER_EGO"):
					return False
				dist = objects.get_distance("ALTER_EGO",dm)
				if dist <= 10.0:
					prohibit_activity(dm)
		if not (kill_count == 3):
			system.notify_timer(data().Timer_RatskullDrogenkuriereAufhalten,data().Timervalue_RatskullDrogenkuriereAufhalten)
		
	## ratskulls steigen in hummer ein
	#if id==data().Timer_RatsSteigenEinInHummer:
	#	dialogs.onDlg_062_DeavtivateRatskullToEnterHummer("RATSKULL_HUMMER_1")

	## general lewis gibt befehle an rekruten
	if id==data().Timer_GeneralBefehltRekruten:
		
		if not data().recruit_ta_active:
			data().recruit_ta_active = True
			for id in NPC_RECRUITS.keys():
				character.set_approachable_state(id,APPROACHABLE)
				allow_activity(id)
			allow_activity("GENERAL_LEWIS")
		if not dialog.is_dialog_active():
			if get_location("RECRUIT_SANCHEZ") == 1:
				dialogs.initDlg_002_GeneraGibtRekrutenBefehle()
		else:
			system.notify_timer(data().Timer_GeneralBefehltRekruten,random.randint(1,2)*data().Timervalue_GeneralBefehltRekruten)
	
	## hummer szene zuende
	if id==data().Timer_HummerSzeneEnde:
		if not data().spieler_von_wesley_betrogen:
			dialogs.initDlg_062_ContinueAfterRatskullsComeOutOfExplosion()
		else:
			dialogs.initDlg_078_ContinueAfterRatskullsComeOutOfExplosion()

	## hummer ist explodiert 
	if id==data().Timer_HummerExplodiert:
		if not data().spieler_von_wesley_betrogen:
			dialogs.initDlg_062_ContinueAfterExplosion()
		else:
			dialogs.initDlg_078_ContinueAfterExplosion()
	
	## wir fangen uns den seeker
	if id==data().Timer_PatrickAufhalten:
		if not data().seeker_aufgehalten:
			if objects.is_active("PATRICK"):
				for pc in system.get_pcs():
					if (objects.get_distance(pc,"PATRICK") <= 8.0):
						objects.cancel_commandos("PATRICK")
						data().seeker_aufgehalten = True
						objects.turn_to_object("PATRICK","ALTER_EGO")
						if not system.is_cutscene and not dialog.is_dialog_active():
							dialogs.initCutscene_067_SeekerWillFluechten()
				if not data().seeker_aufgehalten:
					system.notify_timer(data().Timer_PatrickAufhalten,data().Timervalue_PatrickAufhalten)
			else:
				data().seeker_aufgehalten = True
		
	## dan flieht endlich wirklich
	if id==data().Timer_DanFlucht:
		if not objects.is_destroyed("DAN"):
			for p in ROUTE_PHOENIX:
				if not p == ROUTE_PHOENIX[len(ROUTE_PHOENIX)-1]:
					objects.move_to("DAN",p[0],p[1],"landscape",MT_SLOW)
				else:
					objects.move_to("DAN",p[0],p[1],"landscape",MT_SLOW, callback=["ONEND", deactivate])
	
	## dan flieht, kann aufgehalten werden
	if id==data().Timer_DanAufhalten:
		if not objects.is_destroyed("DAN"):
			if not objects.exists("ALTER_EGO"):
				return False
			if (objects.get_distance("ALTER_EGO","DAN") <= 4.0):
				objects.cancel_commandos("DAN")
				objects.turn_to_object("DAN","ALTER_EGO")
			else:
				system.notify_timer(data().Timer_DanAufhalten,data().Timervalue_DanAufhalten)

	# letzte chance Olivia zu retten
	if (id==data().Timer_Olivias_Tod):
		if not data().Sekte_Tod1:
			if not objects.is_destroyed("SECT_PRIEST"):
				system.start_cutscene()
				system.set_camera_view(CAMVIEW_RITUAL_2)
				objects.cancel_commandos(object="OLIVIA")
				objects.cancel_commandos(object="SECT_PRIEST")
				objects.create_item_in_inventory("SECT_PRIEST","SET_BIG_KNIFE")
				character.equip("SECT_PRIEST","SET_BIG_KNIFE")
				objects.turn_to_object("SECT_PRIEST","OLIVIA", callback=["ONEND", Lambda('objects.set_immortal_state("OLIVIA", False)')])
				character.play_animation("OLIVIA", "CM_NPC_STEHEN_OPFERUNG_OPFER", callback=["ONEND", Lambda('objects.set_attribute("OLIVIA","hitpoints", -5)')])
				character.play_animation("SECT_PRIEST", "CM_NPC_STEHEN_OPFERUNG_HENKER", callback=["ONEND",Das_Erstechen_von_Olivia])

	if id==data().Timer_Sekte_6:
		Letztes_Mitglied(data().last_sectarian)

	if id==data().Timer_stehen:
		character.set_approachable_state("IAN",NOTAPPROACHABLE)
		character.set_approachable_state("PAULA",NOTAPPROACHABLE)
		character.set_approachable_state("LINDA",NOTAPPROACHABLE)
		objects.move_to("IAN", 322,933, "landscape",MT_SLOW,["ONEND",deactivate])
		objects.move_to("PAULA", 322,933, "landscape",MT_FAST,["ONEND",deactivate])
		objects.move_to("LINDA", 322,933, "landscape",MT_SLOW,["ONEND",deactivate])
		system.set_qb_entry_state(data().QB_011,IMPOSSIBLE)
	
	if id == data().Timer_SpawnTimeChecker:
		clock = system.get_mission_time().get_day_time()
		if (clock >= time("06:00:00") and clock < time("22:00:00")):
			spawnanimals.spawnAnimals(INACTIVE)
		else:
			spawnanimals.spawnAnimals(ACTIVE)
		system.notify_timer(data().Timer_SpawnTimeChecker,data().Timervalue_SpawnTimeChecker)
	return None

def Das_Erstechen_von_Olivia(id):
	dialogs.initDlg_031_Das_Erstechen()

		
		
	

def kill():
	for id in NPC_RATSKULLS:
		objects.destroy(id)

## helper: an explision effect
def explode(object_id, count=1, radius=2.0):
	pos = objects.get_position(object_id)
	while count:
		count -= 1
		nx,ny=pos[0]-radius,pos[1]-radius
		dx, dy = random.random(),random.random()
		nx = nx + (dx * radius)
		ny = ny + (dy * radius)
		fx_object_id = random.choice([fx_explosion,fx_explosion_medium])#,fx_explosion_big])#,fx_explosion_humongous])
		sound_object_id = random.choice(['grenade_explo_frag','grenade_explo_rpg7','various_explosive_explo'])
		system.start_effect( 
			startx=nx,starty=ny,startz=0,
			dirx=nx,diry=ny,dirz=0,
			parameter=fx_object_id)
		sounds.play_3d_sound(sfx_id=sound_object_id,x=nx,y=ny,z=0)

# callback zum start einer cutscene
def on_begin_cutscene():

	mobs = system.get_pcs() + system.get_animals() + system.get_npcs()
	
	system_events.handle_vehicles_in_cutscene_on_begin()
	
	for mob in mobs:
		system_events.save_foes(mob)
		system_events.save_speedfactor(mob)

		if mob in system.get_pcs():
			objects.cancel_commandos( mob )
			if data().cutscene_standup:
				import dynamic_camera
				dynamic_camera.set_body_mode(char_id = mob)
	# make sure AE is available
	if objects.is_unconscious("ALTER_EGO"):
		import object_events
		object_events.on_resuscitate("ALTER_EGO", "ALTER_EGO", False)

	for id in (system.get_npcs() + system.get_animals()):
		objects.set_attribute(id,"visibility",UIVIS_VISIBLE)
		objects.set_attribute(id,"visibility_fade",False)

# callback zum ende einer cutscene
def on_end_cutscene():
	
	system_events.handle_vehicles_in_cutscenes_on_end()
	mobs = system.get_pcs() + system.get_animals() + system.get_npcs()
	for mob in mobs:
		system_events.restore_foes(mob)
		system_events.restore_speedfactor(mob)

	for id in (system.get_npcs() + system.get_animals()):
		objects.set_attribute(id,"visibility_fade",True)
	data().cutscene_standup = True

def init_character_states():
	npcs = system.get_npcs()
	for npc in npcs:
		objects.set_immortal_state(npc, False)
		if ((npc not in NPC_RATSKULLS) and 
			(npc not in NPC_RATSKULL_DRUG_MULES) and
			(npc not in NPC_ROWDIES) and 
			(npc not in RATSKULLS_HUMMER) and 
			(npc not in NPC_SEKTE) and
			(npc not in ["PHOENIX"])):
			objects.set_immortal_state(npc, True)
		if objects.has_attribute(npc,"zone_transfer"):
			if objects.get_attribute(npc,"zone_transfer"):
				if npc in ["FRANKLIN", "ABEL", "ANIE", "IAN", "LINDA", "PAULA", "ABRAHAM", "MICKEY", "SUE_Z7", "FJODR"]:
					objects.set_immortal_state(npc, True)
	
	for npc in NPC_RATSKULLS + NPC_RATSKULL_DRUG_MULES:
		character.set_approachable_state(npc, NOTAPPROACHABLE)
		
	character.set_approachable_state("PHOENIX", NOTAPPROACHABLE)
	
	for npc in NPC_MUSTAFA:
		objects.set_immortal_state(npc, False)
	
	for animal in system.get_animals():
		objects.set_attribute(animal, "foes", ["UISPIELER"])
	
	objects.set_immortal_state("TIZOC", True)
	objects.set_immortal_state("SCHATTENLEICHE", False)
	
	#chefs in die haeuser
	objects.set_position("RECRUIT_POPE",254,751,grid="ZONE_5_BUILDING_369_INTERIOR_GRID2")
	objects.set_position("RECRUIT_BROKOVICH",264,751,grid="ZONE_5_BUILDING_369_INTERIOR_GRID1")
	objects.set_position("RECRUIT_HILL",261,750,grid="ZONE_5_BUILDING_369_INTERIOR_GRID1")
	objects.set_position("RECRUIT_SANCHEZ",263,756,grid="ZONE_5_BUILDING_369_INTERIOR_GRID3")
	
	character.set_main_quest_npc_state("GENERAL_LEWIS",True)
	character.set_main_quest_npc_state("PHOENIX",True)
	character.set_main_quest_npc_state("TIZOC",True)
	character.set_main_quest_npc_state("PATRICK",True)

def unfoe():
	for npc in system.get_npcs():
		objects.set_attribute(npc, "foes", None)
		
def on_grid_enter( object_id, grid_id, old_grid_id ):
	if objects.is_pc(object_id):
		#drogenausgabestelle
		if grid_id == "ZONE_5_BUILDING_10565_INTERIOR_GRID1":
			if not data().player_see_drugdisposal:
				data().player_see_drugdisposal = True
				dialogs.initDlg_069_SpielerErkenntDrogenAusgabeStelle()
	
	return object_events.on_grid_enter( object_id, grid_id, old_grid_id )

def initVehicles():
	system.create_object("SET_PICKUP2", 640.67,340.43, "Z5 PICKUP", DIR_SOUTH)
	objects.set_attribute("Z5 PICKUP","accepted_drivers",['UISPIELER'])

def InitChestsSafes():
	objects.add_closed_lock("BUILDING_15828", "lock1", closure_type='lock-trap')
	objects.add_closed_lock("BUILDING_15842", "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_15851", "lock1", closure_type='booby-trap')
	objects.add_closed_lock("BUILDING_15855", "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_15856", "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_15864", "lock1", closure_type='booby-trap')
	objects.add_closed_lock("BUILDING_15865", "lock1", closure_type='poison-trap')
	objects.add_closed_lock("BUILDING_13681", "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_15867", "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_13258", "lock1", closure_type='poison-trap')
	objects.add_closed_lock("BUILDING_13517", "lock1", closure_type='normal')
	objects.add_closed_lock("BUILDING_15886", "lock1", closure_type='lock-trap')

def can_steal_from( thief, victim ):
	if victim in ["NICHOLAS", 'PHOENIX'] :
		return False
	return object_events.can_steal_from(thief, victim )

def init_CLIVE():
	system.create_character(
		id="CLIVE",
		gender=MALE,
		party="NPCS",
		x=352.10,
		y=676.73,
		name=globaltext.NAME_CLIVE,
		direction = DIR_NORTH_EAST,
		resourceui="clive.png" )
	objects.set_attribute("CLIVE","faction","VILLAGE_PEOPLE")
	objects.set_attribute("CLIVE","level", 5)
	objects.set_attributes("CLIVE",
		gender=MALE,
		model="low",
		face="clive",
		clothes="ll_seeker",
		skin="white")
	character.update_appearance("CLIVE")
	objects.set_immortal_state('CLIVE', True)
	
	character.set_main_quest_npc_state("CLIVE",True)
	
	if not hasattr(data('zone_5.zone_5'), 'QB_019'): # zzone_9_aim_01
		data().QB_019 = -1
	if data('zone_5.zone_5').QB_019 == -1:
		data().QB_019 = system.register_qb_entry('ZONE5_AIM_19', id_history = 'ZONE5_AIM_19')
	if not hasattr(data('zone_5.zone_5'), 'Clive_gesprochen'):
		data('zone_5.zone_5').Clive_gesprochen = 0
		
	if not hasattr(data('zone_5.zone_5'), 'restart_T_006'):
		data().restart_T_006 = False
		
	if not hasattr(data('zone_5.zone_5'), 'Dlg_085_Ende_2'):
		data().Dlg_085_Ende_2 = False
		
	if not hasattr(data('zone_5.zone_5'), 'Dlg_088_Ende_2'):
		data().Dlg_088_Ende_2 = False
	
def init_patch():
	if "ANIE" in system.get_npcs():
		if objects.is_active("ANIE"):
			data("zone_7.zone_7").anie_folgt = True
	
	if not hasattr(data(), "patch_patrick"):
		objects.create_item_in_inventory("DAMIEN",
			6*["SET_AMMOPACK_5_45_MM"]+#6 Packen 5,45mm Munition
			3*["SET_AMMOPACK_M79_M203"])#3 Packen 40mm HE-Granaten für M79 und M203 zusätzlich
		# Pfeile im Fass
		objects.create_item_in_inventory("BUILDING_3316",equipment=["SET_AMMOPACK_BOLT"])
		# Salbentöpfe für Händler
		objects.create_item_in_inventory("DAMIEN",["SET_OINTMANT_JAR","SET_OINTMANT_JAR","SET_OINTMANT_JAR"])
		
		objects.create_item_in_inventory( 'BUILDING_15886', 'SET_AMMOPACK_7_62_54_MMR' )
		objects.create_item_in_inventory(object="BUILDING_13189",equipment='SET_THROWING_KNIFE' )
		objects.create_item_in_inventory(object="BUILDING_3316",equipment='SET_SHURIKEN' )
		objects.create_item_in_inventory( 'BUILDING_15828', equipment=[ 'SET_DART', 'SET_DART' ] )
		objects.create_item_in_inventory( 'BUILDING_15865', equipment= 'SET_SHURIKEN' )
		data().patch_patrick = 4
	else:
		if not data().patch_patrick:
			data().patch_patrick = 1
			objects.create_item_in_inventory("DAMIEN",
				6*["SET_AMMOPACK_5_45_MM"]+#6 Packen 5,45mm Munition
				3*["SET_AMMOPACK_M79_M203"])#3 Packen 40mm HE-Granaten für M79 und M203 zusätzlich
		if data().patch_patrick < 2:
			data().patch_patrick = 2
			# Pfeile im Fass
			objects.create_item_in_inventory("BUILDING_3316",equipment=["SET_AMMOPACK_BOLT"])
			# Salbentöpfe für Händler
			objects.create_item_in_inventory("DAMIEN",["SET_OINTMANT_JAR","SET_OINTMANT_JAR","SET_OINTMANT_JAR"])
		if data().patch_patrick < 3:
			data().patch_patrick = 3
			# Im Safe im Haus, nahe dem roten Dodgeram
			objects.create_item_in_inventory( 'BUILDING_15886', 'SET_AMMOPACK_7_62_54_MMR' )
		if data().patch_patrick < 4:
			data().patch_patrick = 4
			objects.create_item_in_inventory(object="BUILDING_13189",equipment='SET_THROWING_KNIFE' )
			objects.create_item_in_inventory(object="BUILDING_3316",equipment='SET_SHURIKEN' )
			objects.create_item_in_inventory( 'BUILDING_15828', equipment=[ 'SET_DART', 'SET_DART' ] )
			objects.create_item_in_inventory( 'BUILDING_15865', equipment= 'SET_SHURIKEN' )

	
	init_main_npcs()

	if not hasattr(data('zone_5.zone_5'), 'Kopfe'):
		data().Kopfe = 0
		for i in range(1,6):
			if objects.count_in_inventory("NICHOLAS", QI_WARGHEAD[1]+"_"+str(i)):
				data().Kopfe += 1

	if not hasattr(data(), "Ratskulls_v_1"):
		data().Ratskulls_v_1 = ["RATSKULL_V1_1","RATSKULL_V1_2","RATSKULL_V1_3","RATSKULL_V1_4"]
		data().Ratskulls_v_2 = ["RATSKULL_V2_1","RATSKULL_V2_2"]
		data().Ratskulls_v_3 = ["RATSKULL_V3_1","RATSKULL_V3_2","RATSKULL_V3_3","RATSKULL_V3_4"]
		data().Ratskulls_v_4 = ["RATSKULL_V4_1","RATSKULL_V4_2","RATSKULL_V4_3"]
	
	if 'PEGGY'in system.get_npcs():
		objects.set_active_state("PEGGY",False)
	
	if not hasattr(data('zone_5.zone_5'), 'phoenix_kill'):
		data('zone_5.zone_5').phoenix_kill = False
	
	if (not data().Kopfe == 5) and (not data().player_knows_station_im_wald):
		for id in NPC_SEKTE:
			objects.set_active_state(id,INACTIVE)
		objects.set_active_state("SECTARIAN",INACTIVE)
		objects.set_active_state("OLIVIA",INACTIVE)
	
	if ((system.get_qb_entry_state(data().QB_005) == COMPLETE) and (data().Sekte_Ausgerottet1)):
		system.set_qb_entry_state(data().QB_005,INACTIVE)
		
	if (not objects.is_destroyed("TIZOC")) and data().Sekte_Ausgerottet1:
		objects.step_away("TIZOC",Lambda('allow_activity("TIZOC")'))
	
	for warg in ["WARG_1","WARG_2","WARG_3","WARG_4","WARG_5"]:
		if objects.exists(warg):
			objects.set_attribute(warg,"foes",["UISPIELER"])
	
	if (not hasattr(data('zone_5.zone_5'), 'Region_Olivia_1')):
		data().Region_Olivia_1 = False
	if (not hasattr(data('zone_5.zone_5'), 'Region_Ritual_2')):
		data().Region_Ritual_2 = False
		
	if (hasattr(data('zone_5.zone_5'), 'Region_betreten') and 
	    not data().player_knows_station_im_wald and 
	    not data().Sekte_Tod1):
		   system.notify_region_entered(region="REGION_RITUAL",partyid="UISPIELER")
	
	if (not hasattr(data('zone_5.zone_5'), 'Region_betreten') and 
	    not data().player_knows_station_im_wald and 
	    not data().Sekte_Tod1):
		   data().Region_betreten = False
		   system.notify_region_entered(region="REGION_RITUAL",partyid="UISPIELER")
		   system.notify_region_entered(region="REGION_RITUAL_2",partyid="UISPIELER")
		   system.notify_region_entered(region="REGION_OLIVIA_1",partyid="UISPIELER")
	
	
	if not objects.has_attribute("DAMIEN", "voice_id"):
		objects.set_attribute("DAMIEN", "voice_id", "trader_01")
	
	if not 'CLIVE' in system.get_npcs():
		init_CLIVE()
		
	if not hasattr(data('zone_5.zone_5'), 'warg_getauscht'):
		data().warg_getauscht = False
		
	if not data().warg_getauscht:
		data().warg_getauscht = True
		for warg in ['WARG_1', 'WARG_2', 'WARG_3', 'WARG_4', 'WARG_5']:
			if objects.is_destroyed(warg):
				if not 'SET_WARG_HEAD' in objects.get_inventory_list(warg):
					pos = objects.get_position(warg)
					dir_ = objects.get_direction(warg)
					objects.set_active_state(warg, False)
					system.create_object('RES3D_WARGKADAVER_KOPFLOS', pos[0], pos[1], warg+'KOPFLOS', dir_)
	
	if hasattr(data('zone_5.zone_5'), 'Leiche_Kann_Weg'):
		if not data().Leiche_Kann_Weg:
			objects.set_active_state("SCHATTENLEICHE",True)
	
	# Dialog bei Opferung abbrechen
	if not hasattr(data(),"	Opferung_Active"):
			data().Opferung_Active = False
	
	
	# GNO Abschaltung
	if not hasattr(data(),'Bruch_Mit_Hayes'):
		data().Bruch_Mit_Hayes = False
	
def init_main_npcs():
	npcs = system.get_npcs()
	if "DAMIEN" in npcs:
		character.set_main_quest_npc_state(char="DAMIEN", state=True)
	if "ZACHARY" in npcs:
		character.set_main_quest_npc_state(char="ZACHARY", state=True)

def can_entertain( character_id, object_id ):
	if object_id in ["PHOENIX"]:
		return False
	return object_events.can_entertain( character_id, object_id )
	
def init_difficulty_increase():
	for char_id in NPC_RATSKULLS:
		set_talent(char_id,"light_weapons",'precision')
		objects.set_attribute(char_id,"armor",4)
